# icure_dart_sdk
The iCure Data Stack Application API is the native interface to iCure.

This Dart package is automatically generated by the [OpenAPI Generator](https://icure_dart_sdk-generator.tech) project:

- API version: v2
- Build package: org.openapitools.codegen.languages.DartClientCodegen

## Requirements

Dart 2.12 or later

## Installation & Usage

### Github
If this Dart package is published to Github, add the following dependency to your pubspec.yaml
```
dependencies:
  icure_dart_sdk:
    git: https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```

### Local
To use the package in your local drive, add the following dependency to your pubspec.yaml
```
dependencies:
  icure_dart_sdk:
    path: /path/to/icure_dart_sdk
```

## Tests

TODO

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```dart
import 'package:icure_dart_sdk/api.dart';


final api_instance = AccessLogApi();
final accessLogDto = AccessLogDto(); // AccessLogDto | 

try {
    final result = api_instance.createAccessLog(accessLogDto);
    print(result);
} catch (e) {
    print('Exception when calling AccessLogApi->createAccessLog: $e\n');
}

```

## Documentation for API Endpoints

All URIs are relative to *https://kraken.icure.dev*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*AccessLogApi* | [**createAccessLog**](doc//AccessLogApi.md#createaccesslog) | **POST** /rest/v2/accesslog | Creates an access log
*AccessLogApi* | [**deleteAccessLogs**](doc//AccessLogApi.md#deleteaccesslogs) | **POST** /rest/v2/accesslog/delete/batch | Deletes an access log
*AccessLogApi* | [**findAccessLogsBy**](doc//AccessLogApi.md#findaccesslogsby) | **GET** /rest/v2/accesslog | Get Paginated List of Access logs
*AccessLogApi* | [**findAccessLogsByUserAfterDate**](doc//AccessLogApi.md#findaccesslogsbyuserafterdate) | **GET** /rest/v2/accesslog/byUser | Get Paginated List of Access logs by user after date
*AccessLogApi* | [**getAccessLog**](doc//AccessLogApi.md#getaccesslog) | **GET** /rest/v2/accesslog/{accessLogId} | Gets an access log
*AccessLogApi* | [**listAccessLogsByHCPartyAndPatientForeignKeys**](doc//AccessLogApi.md#listaccesslogsbyhcpartyandpatientforeignkeys) | **GET** /rest/v2/accesslog/byHcPartySecretForeignKeys | List access logs found By Healthcare Party and secret foreign keyelementIds.
*AccessLogApi* | [**modifyAccessLog**](doc//AccessLogApi.md#modifyaccesslog) | **PUT** /rest/v2/accesslog | Modifies an access log
*AgendaApi* | [**createAgenda**](doc//AgendaApi.md#createagenda) | **POST** /rest/v2/agenda | Creates a agenda
*AgendaApi* | [**deleteAgendas**](doc//AgendaApi.md#deleteagendas) | **POST** /rest/v2/agenda/delete/batch | Deletes agendas
*AgendaApi* | [**getAgenda**](doc//AgendaApi.md#getagenda) | **GET** /rest/v2/agenda/{agendaId} | Gets an agenda
*AgendaApi* | [**getAgendas**](doc//AgendaApi.md#getagendas) | **GET** /rest/v2/agenda | Gets all agendas
*AgendaApi* | [**getAgendasForUser**](doc//AgendaApi.md#getagendasforuser) | **GET** /rest/v2/agenda/byUser | Gets all agendas for user
*AgendaApi* | [**getReadableAgendasForUser**](doc//AgendaApi.md#getreadableagendasforuser) | **GET** /rest/v2/agenda/readableForUser | Gets readable agendas for user
*AgendaApi* | [**modifyAgenda**](doc//AgendaApi.md#modifyagenda) | **PUT** /rest/v2/agenda | Modifies an agenda
*AnonymousAccessApi* | [**getAvailabilitiesByPeriodAndCalendarItemTypeId**](doc//AnonymousAccessApi.md#getavailabilitiesbyperiodandcalendaritemtypeid) | **GET** /rest/v2/aa/available/inGroup/{groupId}/forUser/{userId}/type/{getCalendarItemTypeId} | Get Availabilities for HCP and appointmentType
*AnonymousAccessApi* | [**listAppointmentTypesForUser**](doc//AnonymousAccessApi.md#listappointmenttypesforuser) | **GET** /rest/v2/aa/appointmentType/inGroup/{groupId}/forUser/{userId} | List Calendar Item types for a provided group id and user id
*AnonymousAccessApi* | [**listHealthcarePartiesInGroup**](doc//AnonymousAccessApi.md#listhealthcarepartiesingroup) | **GET** /rest/v2/aa/hcparty/inGroup/{groupId} | List healthcare parties for a provided group id
*ApplicationsettingsApi* | [**getApplicationSettings**](doc//ApplicationsettingsApi.md#getapplicationsettings) | **GET** /rest/v2/appsettings | Gets all application settings
*ArticleApi* | [**createArticle**](doc//ArticleApi.md#createarticle) | **POST** /rest/v2/article | Creates a article
*ArticleApi* | [**deleteArticles**](doc//ArticleApi.md#deletearticles) | **POST** /rest/v2/article/delete/batch | Deletes articles
*ArticleApi* | [**getArticle**](doc//ArticleApi.md#getarticle) | **GET** /rest/v2/article/{articleId} | Gets an article
*ArticleApi* | [**getArticles**](doc//ArticleApi.md#getarticles) | **GET** /rest/v2/article | Gets all articles
*ArticleApi* | [**modifyArticle**](doc//ArticleApi.md#modifyarticle) | **PUT** /rest/v2/article | Modifies an article
*AuthApi* | [**login**](doc//AuthApi.md#login) | **POST** /rest/v2/auth/login | login
*AuthApi* | [**logout**](doc//AuthApi.md#logout) | **GET** /rest/v2/auth/logout | logout
*AuthApi* | [**logoutPost**](doc//AuthApi.md#logoutpost) | **POST** /rest/v2/auth/logout | logout
*AuthApi* | [**token**](doc//AuthApi.md#token) | **GET** /rest/v2/auth/token/{method}/{path} | token
*BeefactApi* | [**createBatchAndMessage**](doc//BeefactApi.md#createbatchandmessage) | **POST** /rest/v2/be_efact/{insuranceId}/{newMessageId}/{numericalRef} | create batch and message
*BekmehrApi* | [**checkIfSMFPatientsExists**](doc//BekmehrApi.md#checkifsmfpatientsexists) | **POST** /rest/v2/be_kmehr/smf/{documentId}/checkIfSMFPatientsExists | Check whether patients in SMF already exists in DB
*BekmehrApi* | [**generateContactreportExport**](doc//BekmehrApi.md#generatecontactreportexport) | **POST** /rest/v2/be_kmehr/contactreport/{patientId}/export/{id} | Get Kmehr contactreport
*BekmehrApi* | [**generateDiaryNote**](doc//BekmehrApi.md#generatediarynote) | **POST** /rest/v2/be_kmehr/diarynote/{patientId}/export | Generate diarynote
*BekmehrApi* | [**generateLabresultExport**](doc//BekmehrApi.md#generatelabresultexport) | **POST** /rest/v2/be_kmehr/labresult/{patientId}/export/{id} | Get Kmehr labresult
*BekmehrApi* | [**generateMedicationSchemeExport**](doc//BekmehrApi.md#generatemedicationschemeexport) | **POST** /rest/v2/be_kmehr/medicationscheme/{patientId}/export | Get Medicationscheme export
*BekmehrApi* | [**generateNoteExport**](doc//BekmehrApi.md#generatenoteexport) | **POST** /rest/v2/be_kmehr/note/{patientId}/export/{id} | Get Kmehr note
*BekmehrApi* | [**generatePatientInfoExport**](doc//BekmehrApi.md#generatepatientinfoexport) | **POST** /rest/v2/be_kmehr/patientinfo/{patientId}/export | Get KMEHR Patient Info export
*BekmehrApi* | [**generatePrescriptionExport**](doc//BekmehrApi.md#generateprescriptionexport) | **POST** /rest/v2/be_kmehr/prescription/{patientId}/export/{id} | Get Kmehr prescription
*BekmehrApi* | [**generateReportExport**](doc//BekmehrApi.md#generatereportexport) | **POST** /rest/v2/be_kmehr/report/{patientId}/export/{id} | Get Kmehr report
*BekmehrApi* | [**generateRequestExport**](doc//BekmehrApi.md#generaterequestexport) | **POST** /rest/v2/be_kmehr/request/{patientId}/export/{id} | Get Kmehr request
*BekmehrApi* | [**generateResultExport**](doc//BekmehrApi.md#generateresultexport) | **POST** /rest/v2/be_kmehr/result/{patientId}/export/{id} | Get Kmehr result
*BekmehrApi* | [**generateSmfExport**](doc//BekmehrApi.md#generatesmfexport) | **POST** /rest/v2/be_kmehr/smf/{patientId}/export | Get SMF (Software Medical File) export
*BekmehrApi* | [**generateSumehr**](doc//BekmehrApi.md#generatesumehr) | **POST** /rest/v2/be_kmehr/sumehr/{patientId}/export | Generate sumehr
*BekmehrApi* | [**generateSumehrV2**](doc//BekmehrApi.md#generatesumehrv2) | **POST** /rest/v2/be_kmehr/sumehrv2/{patientId}/export | Generate sumehr
*BekmehrApi* | [**getSumehrContent**](doc//BekmehrApi.md#getsumehrcontent) | **POST** /rest/v2/be_kmehr/sumehr/{patientId}/content | Get sumehr elements
*BekmehrApi* | [**getSumehrMd5**](doc//BekmehrApi.md#getsumehrmd5) | **POST** /rest/v2/be_kmehr/sumehr/{patientId}/md5 | Check sumehr signature
*BekmehrApi* | [**getSumehrV2Content**](doc//BekmehrApi.md#getsumehrv2content) | **POST** /rest/v2/be_kmehr/sumehrv2/{patientId}/content | Get sumehr elements
*BekmehrApi* | [**getSumehrV2Md5**](doc//BekmehrApi.md#getsumehrv2md5) | **POST** /rest/v2/be_kmehr/sumehrv2/{patientId}/md5 | Check sumehr signature
*BekmehrApi* | [**importMedicationScheme**](doc//BekmehrApi.md#importmedicationscheme) | **POST** /rest/v2/be_kmehr/medicationscheme/{documentId}/import | Import MedicationScheme into patient(s) using existing document
*BekmehrApi* | [**importSmf**](doc//BekmehrApi.md#importsmf) | **POST** /rest/v2/be_kmehr/smf/{documentId}/import | Import SMF into patient(s) using existing document
*BekmehrApi* | [**importSumehr**](doc//BekmehrApi.md#importsumehr) | **POST** /rest/v2/be_kmehr/sumehr/{documentId}/import | Import sumehr into patient(s) using existing document
*BekmehrApi* | [**importSumehrByItemId**](doc//BekmehrApi.md#importsumehrbyitemid) | **POST** /rest/v2/be_kmehr/sumehr/{documentId}/importbyitemid | Import sumehr into patient(s) using existing document
*BekmehrApi* | [**isSumehrV2Valid**](doc//BekmehrApi.md#issumehrv2valid) | **POST** /rest/v2/be_kmehr/sumehrv2/{patientId}/valid | Get sumehr validity
*BekmehrApi* | [**isSumehrValid**](doc//BekmehrApi.md#issumehrvalid) | **POST** /rest/v2/be_kmehr/sumehr/{patientId}/valid | Get sumehr validity
*BekmehrApi* | [**validateSumehr**](doc//BekmehrApi.md#validatesumehr) | **POST** /rest/v2/be_kmehr/sumehr/{patientId}/validate | Validate sumehr
*BekmehrApi* | [**validateSumehrV2**](doc//BekmehrApi.md#validatesumehrv2) | **POST** /rest/v2/be_kmehr/sumehrv2/{patientId}/validate | Validate sumehr
*BeresultexportApi* | [**exportHealthOne**](doc//BeresultexportApi.md#exporthealthone) | **POST** /rest/v2/be_result_export/hl1/{fromHcpId}/{toHcpId}/{patId}/{date}/{ref} | Export data
*BeresultexportApi* | [**exportKmehrReport**](doc//BeresultexportApi.md#exportkmehrreport) | **POST** /rest/v2/be_result_export/kmehrreport/{fromHcpId}/{toHcpId}/{patId}/{date}/{ref} | Export data
*BeresultexportApi* | [**exportMedidoc**](doc//BeresultexportApi.md#exportmedidoc) | **POST** /rest/v2/be_result_export/medidoc/{fromHcpId}/{toHcpId}/{patId}/{date}/{ref} | Export data
*BeresultimportApi* | [**canHandle**](doc//BeresultimportApi.md#canhandle) | **GET** /rest/v2/be_result_import/canhandle/{id} | Can we handle this document
*BeresultimportApi* | [**doImport**](doc//BeresultimportApi.md#doimport) | **GET** /rest/v2/be_result_import/import/{documentId}/{hcpId}/{language} | import document
*BeresultimportApi* | [**getInfos**](doc//BeresultimportApi.md#getinfos) | **GET** /rest/v2/be_result_import/infos/{id} | Extract general infos from document
*Besamv2Api* | [**findAmpsByDmppCode**](doc//Besamv2Api.md#findampsbydmppcode) | **GET** /rest/v2/be_samv2/amp/byDmppCode/{dmppCode} | Finding AMPs by dmpp code
*Besamv2Api* | [**findPaginatedAmpsByAtc**](doc//Besamv2Api.md#findpaginatedampsbyatc) | **GET** /rest/v2/be_samv2/vmp/byAtc/{atcCode} | Finding AMPs by atc code with pagination.
*Besamv2Api* | [**findPaginatedAmpsByGroupCode**](doc//Besamv2Api.md#findpaginatedampsbygroupcode) | **GET** /rest/v2/be_samv2/amp/byGroupCode/{vmpgCode} | Finding AMPs by group with pagination.
*Besamv2Api* | [**findPaginatedAmpsByGroupId**](doc//Besamv2Api.md#findpaginatedampsbygroupid) | **GET** /rest/v2/be_samv2/amp/byGroupId/{vmpgId} | Finding AMPs by group with pagination.
*Besamv2Api* | [**findPaginatedAmpsByLabel**](doc//Besamv2Api.md#findpaginatedampsbylabel) | **GET** /rest/v2/be_samv2/amp | Finding AMPs by label with pagination.
*Besamv2Api* | [**findPaginatedAmpsByVmpCode**](doc//Besamv2Api.md#findpaginatedampsbyvmpcode) | **GET** /rest/v2/be_samv2/amp/byVmpCode/{vmpCode} | Finding AMPs by vmp code with pagination.
*Besamv2Api* | [**findPaginatedAmpsByVmpId**](doc//Besamv2Api.md#findpaginatedampsbyvmpid) | **GET** /rest/v2/be_samv2/amp/byVmpId/{vmpId} | Finding AMPs by vmp id with pagination.
*Besamv2Api* | [**findPaginatedNmpsByLabel**](doc//Besamv2Api.md#findpaginatednmpsbylabel) | **GET** /rest/v2/be_samv2/nmp | Finding NMPs by label with pagination.
*Besamv2Api* | [**findPaginatedVmpGroupsByLabel**](doc//Besamv2Api.md#findpaginatedvmpgroupsbylabel) | **GET** /rest/v2/be_samv2/vmpgroup | Finding VMP groups by language label with pagination.
*Besamv2Api* | [**findPaginatedVmpGroupsByVmpGroupCode**](doc//Besamv2Api.md#findpaginatedvmpgroupsbyvmpgroupcode) | **GET** /rest/v2/be_samv2/vmpgroup/byGroupCode/{vmpgCode} | Finding VMP groups by cmpgCode with pagination.
*Besamv2Api* | [**findPaginatedVmpsByGroupCode**](doc//Besamv2Api.md#findpaginatedvmpsbygroupcode) | **GET** /rest/v2/be_samv2/vmp/byGroupCode/{vmpgCode} | Finding VMPs by group with pagination.
*Besamv2Api* | [**findPaginatedVmpsByGroupId**](doc//Besamv2Api.md#findpaginatedvmpsbygroupid) | **GET** /rest/v2/be_samv2/vmp/byGroupId/{vmpgId} | Finding VMPs by group with pagination.
*Besamv2Api* | [**findPaginatedVmpsByLabel**](doc//Besamv2Api.md#findpaginatedvmpsbylabel) | **GET** /rest/v2/be_samv2/vmp | Finding VMPs by label with pagination.
*Besamv2Api* | [**findPaginatedVmpsByVmpCode**](doc//Besamv2Api.md#findpaginatedvmpsbyvmpcode) | **GET** /rest/v2/be_samv2/vmp/byVmpCode/{vmpCode} | Finding VMPs by group with pagination.
*Besamv2Api* | [**getSamVersion**](doc//Besamv2Api.md#getsamversion) | **GET** /rest/v2/be_samv2/v | Get Samv2 version.
*Besamv2Api* | [**listAmpsByDmppCodes**](doc//Besamv2Api.md#listampsbydmppcodes) | **POST** /rest/v2/be_samv2/amp/byDmppCodes | Finding AMPs by dmpp code
*Besamv2Api* | [**listAmpsByGroupCodes**](doc//Besamv2Api.md#listampsbygroupcodes) | **POST** /rest/v2/be_samv2/amp/byGroupCodes | Finding AMPs by group.
*Besamv2Api* | [**listAmpsByGroupIds**](doc//Besamv2Api.md#listampsbygroupids) | **POST** /rest/v2/be_samv2/amp/byGroupIds | Finding AMPs by group.
*Besamv2Api* | [**listAmpsByVmpCodes**](doc//Besamv2Api.md#listampsbyvmpcodes) | **POST** /rest/v2/be_samv2/amp/byVmpCodes | Finding AMPs by vmp code.
*Besamv2Api* | [**listAmpsByVmpIds**](doc//Besamv2Api.md#listampsbyvmpids) | **POST** /rest/v2/be_samv2/amp/byVmpIds | Finding AMPs by vmp id.
*Besamv2Api* | [**listNmpsByCnks**](doc//Besamv2Api.md#listnmpsbycnks) | **POST** /rest/v2/be_samv2/nmp/byCnks | Finding NMPs by cnk id.
*Besamv2Api* | [**listPharmaceuticalForms**](doc//Besamv2Api.md#listpharmaceuticalforms) | **GET** /rest/v2/be_samv2/pharmaform | List all pharmaceutical forms.
*Besamv2Api* | [**listSubstances**](doc//Besamv2Api.md#listsubstances) | **GET** /rest/v2/be_samv2/substance | List all substances.
*Besamv2Api* | [**listVmpGroupsByVmpGroupCodes**](doc//Besamv2Api.md#listvmpgroupsbyvmpgroupcodes) | **POST** /rest/v2/be_samv2/vmpgroup/byGroupCodes | Finding AMPs by group.
*Besamv2Api* | [**listVmpsByGroupIds**](doc//Besamv2Api.md#listvmpsbygroupids) | **POST** /rest/v2/be_samv2/vmp/byGroupIds | Finding VMPs by group.
*Besamv2Api* | [**listVmpsByVmpCodes**](doc//Besamv2Api.md#listvmpsbyvmpcodes) | **POST** /rest/v2/be_samv2/vmp/byVmpCodes | Finding VMPs by group.
*CalendarItemApi* | [**createCalendarItem**](doc//CalendarItemApi.md#createcalendaritem) | **POST** /rest/v2/calendarItem | Creates a calendarItem
*CalendarItemApi* | [**deleteCalendarItem**](doc//CalendarItemApi.md#deletecalendaritem) | **POST** /rest/v2/calendarItem/{calendarItemIds} | Deletes an calendarItem
*CalendarItemApi* | [**deleteCalendarItems**](doc//CalendarItemApi.md#deletecalendaritems) | **POST** /rest/v2/calendarItem/delete/batch | Deletes calendarItems
*CalendarItemApi* | [**findCalendarItemsByHCPartyPatientForeignKeys**](doc//CalendarItemApi.md#findcalendaritemsbyhcpartypatientforeignkeys) | **GET** /rest/v2/calendarItem/byHcPartySecretForeignKeys | Find CalendarItems by hcparty and patient
*CalendarItemApi* | [**findCalendarItemsByRecurrenceId**](doc//CalendarItemApi.md#findcalendaritemsbyrecurrenceid) | **GET** /rest/v2/calendarItem/byRecurrenceId | Find CalendarItems by recurrenceId
*CalendarItemApi* | [**getCalendarItem**](doc//CalendarItemApi.md#getcalendaritem) | **GET** /rest/v2/calendarItem/{calendarItemId} | Gets an calendarItem
*CalendarItemApi* | [**getCalendarItems**](doc//CalendarItemApi.md#getcalendaritems) | **GET** /rest/v2/calendarItem | Gets all calendarItems
*CalendarItemApi* | [**getCalendarItemsByPeriodAndHcPartyId**](doc//CalendarItemApi.md#getcalendaritemsbyperiodandhcpartyid) | **POST** /rest/v2/calendarItem/byPeriodAndHcPartyId | Get CalendarItems by Period and HcPartyId
*CalendarItemApi* | [**getCalendarItemsWithIds**](doc//CalendarItemApi.md#getcalendaritemswithids) | **POST** /rest/v2/calendarItem/byIds | Get calendarItems by ids
*CalendarItemApi* | [**getCalendarsByPeriodAndAgendaId**](doc//CalendarItemApi.md#getcalendarsbyperiodandagendaid) | **POST** /rest/v2/calendarItem/byPeriodAndAgendaId | Get CalendarItems by Period and AgendaId
*CalendarItemApi* | [**modifyCalendarItem**](doc//CalendarItemApi.md#modifycalendaritem) | **PUT** /rest/v2/calendarItem | Modifies an calendarItem
*CalendarItemApi* | [**setCalendarItemsDelegations**](doc//CalendarItemApi.md#setcalendaritemsdelegations) | **POST** /rest/v2/calendarItem/delegations | Update delegations in calendarItems
*CalendarItemTypeApi* | [**createCalendarItemType**](doc//CalendarItemTypeApi.md#createcalendaritemtype) | **POST** /rest/v2/calendarItemType | Creates a calendarItemType
*CalendarItemTypeApi* | [**deleteCalendarItemTypes**](doc//CalendarItemTypeApi.md#deletecalendaritemtypes) | **POST** /rest/v2/calendarItemType/delete/batch | Deletes calendarItemTypes
*CalendarItemTypeApi* | [**getCalendarItemType**](doc//CalendarItemTypeApi.md#getcalendaritemtype) | **GET** /rest/v2/calendarItemType/{calendarItemTypeId} | Gets a calendarItemType
*CalendarItemTypeApi* | [**getCalendarItemTypes**](doc//CalendarItemTypeApi.md#getcalendaritemtypes) | **GET** /rest/v2/calendarItemType | Gets all calendarItemTypes
*CalendarItemTypeApi* | [**getCalendarItemTypesIncludeDeleted**](doc//CalendarItemTypeApi.md#getcalendaritemtypesincludedeleted) | **GET** /rest/v2/calendarItemType/includeDeleted | Gets all calendarItemTypes include deleted
*CalendarItemTypeApi* | [**modifyCalendarItemType**](doc//CalendarItemTypeApi.md#modifycalendaritemtype) | **PUT** /rest/v2/calendarItemType | Modifies an calendarItemType
*ClassificationApi* | [**createClassification**](doc//ClassificationApi.md#createclassification) | **POST** /rest/v2/classification | Create a classification with the current user
*ClassificationApi* | [**deleteClassifications**](doc//ClassificationApi.md#deleteclassifications) | **POST** /rest/v2/classification/delete/batch | Delete classification Templates.
*ClassificationApi* | [**findClassificationsByHCPartyPatientForeignKeys**](doc//ClassificationApi.md#findclassificationsbyhcpartypatientforeignkeys) | **GET** /rest/v2/classification/byHcPartySecretForeignKeys | List classification Templates found By Healthcare Party and secret foreign keyelementIds.
*ClassificationApi* | [**getClassification**](doc//ClassificationApi.md#getclassification) | **GET** /rest/v2/classification/{classificationId} | Get a classification Template
*ClassificationApi* | [**getClassificationByHcPartyId**](doc//ClassificationApi.md#getclassificationbyhcpartyid) | **GET** /rest/v2/classification/byIds/{ids} | Get a list of classifications
*ClassificationApi* | [**modifyClassification**](doc//ClassificationApi.md#modifyclassification) | **PUT** /rest/v2/classification | Modify a classification Template
*ClassificationApi* | [**newClassificationDelegations**](doc//ClassificationApi.md#newclassificationdelegations) | **POST** /rest/v2/classification/{classificationId}/delegate | Delegates a classification to a healthcare party
*ClassificationApi* | [**setClassificationsDelegations**](doc//ClassificationApi.md#setclassificationsdelegations) | **POST** /rest/v2/classification/delegations | Update delegations in classification
*ClassificationTemplateApi* | [**createClassificationTemplate**](doc//ClassificationTemplateApi.md#createclassificationtemplate) | **POST** /rest/v2/classificationTemplate | Create a classification Template with the current user
*ClassificationTemplateApi* | [**deleteClassificationTemplates**](doc//ClassificationTemplateApi.md#deleteclassificationtemplates) | **POST** /rest/v2/classificationTemplate/delete/batch | Delete classification Templates.
*ClassificationTemplateApi* | [**findClassificationTemplatesBy**](doc//ClassificationTemplateApi.md#findclassificationtemplatesby) | **GET** /rest/v2/classificationTemplate | List all classification templates with pagination
*ClassificationTemplateApi* | [**getClassificationTemplate**](doc//ClassificationTemplateApi.md#getclassificationtemplate) | **GET** /rest/v2/classificationTemplate/{classificationTemplateId} | Get a classification Template
*ClassificationTemplateApi* | [**getClassificationTemplateByIds**](doc//ClassificationTemplateApi.md#getclassificationtemplatebyids) | **GET** /rest/v2/classificationTemplate/byIds/{ids} | Get a list of classifications Templates
*ClassificationTemplateApi* | [**listClassificationTemplatesByHCPartyPatientForeignKeys**](doc//ClassificationTemplateApi.md#listclassificationtemplatesbyhcpartypatientforeignkeys) | **GET** /rest/v2/classificationTemplate/byHcPartySecretForeignKeys | List classification Templates found By Healthcare Party and secret foreign keyelementIds.
*ClassificationTemplateApi* | [**modifyClassificationTemplate**](doc//ClassificationTemplateApi.md#modifyclassificationtemplate) | **PUT** /rest/v2/classificationTemplate | Modify a classification Template
*ClassificationTemplateApi* | [**newClassificationTemplateDelegations**](doc//ClassificationTemplateApi.md#newclassificationtemplatedelegations) | **POST** /rest/v2/classificationTemplate/{classificationTemplateId}/delegate | Delegates a classification Template to a healthcare party
*CodeApi* | [**createCode**](doc//CodeApi.md#createcode) | **POST** /rest/v2/code | Create a Code
*CodeApi* | [**filterCodesBy**](doc//CodeApi.md#filtercodesby) | **POST** /rest/v2/code/filter | Filter codes 
*CodeApi* | [**findCodesByLabel**](doc//CodeApi.md#findcodesbylabel) | **GET** /rest/v2/code/byLabel | Finding codes by code, type and version with pagination.
*CodeApi* | [**findCodesByLink**](doc//CodeApi.md#findcodesbylink) | **GET** /rest/v2/code/byLink/{linkType} | Finding codes by code, type and version with pagination.
*CodeApi* | [**findCodesByType**](doc//CodeApi.md#findcodesbytype) | **GET** /rest/v2/code | Finding codes by code, type and version with pagination.
*CodeApi* | [**getCode**](doc//CodeApi.md#getcode) | **GET** /rest/v2/code/{codeId} | Get a code
*CodeApi* | [**getCodeWithParts**](doc//CodeApi.md#getcodewithparts) | **GET** /rest/v2/code/{type}/{code}/{version} | Get a code
*CodeApi* | [**getCodes**](doc//CodeApi.md#getcodes) | **POST** /rest/v2/code/byIds | Get a list of codes by ids
*CodeApi* | [**importCodes**](doc//CodeApi.md#importcodes) | **POST** /rest/v2/code/{codeType} | Import codes
*CodeApi* | [**listCodeTypesBy**](doc//CodeApi.md#listcodetypesby) | **GET** /rest/v2/code/codetype/byRegionType | Finding code types.
*CodeApi* | [**listCodesByRegionTypeCodeVersion**](doc//CodeApi.md#listcodesbyregiontypecodeversion) | **GET** /rest/v2/code/byRegionTypeCode | Finding codes by code, type and version
*CodeApi* | [**listTagTypesBy**](doc//CodeApi.md#listtagtypesby) | **GET** /rest/v2/code/tagtype/byRegionType | Finding tag types.
*CodeApi* | [**matchCodesBy**](doc//CodeApi.md#matchcodesby) | **POST** /rest/v2/code/match | Get ids of code matching the provided filter for the current user (HcParty) 
*CodeApi* | [**modifyCode**](doc//CodeApi.md#modifycode) | **PUT** /rest/v2/code | Modify a code
*ContactApi* | [**closeForHCPartyPatientForeignKeys**](doc//ContactApi.md#closeforhcpartypatientforeignkeys) | **PUT** /rest/v2/contact/byHcPartySecretForeignKeys/close | Close contacts for Healthcare Party and secret foreign keys.
*ContactApi* | [**createContact**](doc//ContactApi.md#createcontact) | **POST** /rest/v2/contact | Create a contact with the current user
*ContactApi* | [**createContacts**](doc//ContactApi.md#createcontacts) | **POST** /rest/v2/contact/batch | Create a batch of contacts
*ContactApi* | [**deleteContacts**](doc//ContactApi.md#deletecontacts) | **POST** /rest/v2/contact/delete/batch | Delete contacts.
*ContactApi* | [**filterContactsBy**](doc//ContactApi.md#filtercontactsby) | **POST** /rest/v2/contact/filter | List contacts for the current user (HcParty) or the given hcparty in the filter 
*ContactApi* | [**filterServicesBy**](doc//ContactApi.md#filterservicesby) | **POST** /rest/v2/contact/service/filter | List services for the current user (HcParty) or the given hcparty in the filter 
*ContactApi* | [**findContactsByOpeningDate**](doc//ContactApi.md#findcontactsbyopeningdate) | **GET** /rest/v2/contact/byOpeningDate | List contacts by opening date parties with(out) pagination
*ContactApi* | [**getContact**](doc//ContactApi.md#getcontact) | **GET** /rest/v2/contact/{contactId} | Get a contact
*ContactApi* | [**getContacts**](doc//ContactApi.md#getcontacts) | **POST** /rest/v2/contact/byIds | Get contacts
*ContactApi* | [**getEmptyContent**](doc//ContactApi.md#getemptycontent) | **GET** /rest/v2/contact/service/content/empty | Get an empty content
*ContactApi* | [**getServiceCodesOccurences**](doc//ContactApi.md#getservicecodesoccurences) | **GET** /rest/v2/contact/service/codes/{codeType}/{minOccurences} | Get the list of all used codes frequencies in services
*ContactApi* | [**getServices**](doc//ContactApi.md#getservices) | **POST** /rest/v2/contact/service | List services with provided ids 
*ContactApi* | [**getServicesLinkedTo**](doc//ContactApi.md#getserviceslinkedto) | **POST** /rest/v2/contact/service/linkedTo | List services linked to provided ids 
*ContactApi* | [**listContactByHCPartyServiceId**](doc//ContactApi.md#listcontactbyhcpartyserviceid) | **GET** /rest/v2/contact/byHcPartyServiceId | List contacts found By Healthcare Party and service Id.
*ContactApi* | [**listContactsByExternalId**](doc//ContactApi.md#listcontactsbyexternalid) | **POST** /rest/v2/contact/byExternalId | List contacts found By externalId.
*ContactApi* | [**listContactsByHCPartyAndFormId**](doc//ContactApi.md#listcontactsbyhcpartyandformid) | **GET** /rest/v2/contact/byHcPartyFormId | List contacts found By Healthcare Party and form Id.
*ContactApi* | [**listContactsByHCPartyAndFormIds**](doc//ContactApi.md#listcontactsbyhcpartyandformids) | **POST** /rest/v2/contact/byHcPartyFormIds | List contacts found By Healthcare Party and form Id.
*ContactApi* | [**listContactsByHCPartyAndPatientForeignKeys**](doc//ContactApi.md#listcontactsbyhcpartyandpatientforeignkeys) | **POST** /rest/v2/contact/byHcPartyPatientForeignKeys | List contacts found By Healthcare Party and Patient foreign keys.
*ContactApi* | [**listContactsByHCPartyAndPatientSecretFKeys**](doc//ContactApi.md#listcontactsbyhcpartyandpatientsecretfkeys) | **GET** /rest/v2/contact/byHcPartySecretForeignKeys | List contacts found By Healthcare Party and secret foreign keys.
*ContactApi* | [**listContactsDelegationsStubsByHCPartyAndPatientForeignKeys**](doc//ContactApi.md#listcontactsdelegationsstubsbyhcpartyandpatientforeignkeys) | **GET** /rest/v2/contact/byHcPartySecretForeignKeys/delegations | List contacts found By Healthcare Party and secret foreign keys.
*ContactApi* | [**listServicesByAssociationId**](doc//ContactApi.md#listservicesbyassociationid) | **GET** /rest/v2/contact/service/associationId | List services by related association id
*ContactApi* | [**listServicesByHealthElementId**](doc//ContactApi.md#listservicesbyhealthelementid) | **GET** /rest/v2/contact/service/healthElementId/{healthElementId} | List services linked to a health element
*ContactApi* | [**matchContactsBy**](doc//ContactApi.md#matchcontactsby) | **POST** /rest/v2/contact/match | Get ids of contacts matching the provided filter for the current user (HcParty) 
*ContactApi* | [**modifyContact**](doc//ContactApi.md#modifycontact) | **PUT** /rest/v2/contact | Modify a contact
*ContactApi* | [**modifyContacts**](doc//ContactApi.md#modifycontacts) | **PUT** /rest/v2/contact/batch | Modify a batch of contacts
*ContactApi* | [**modifyContactsDelegations**](doc//ContactApi.md#modifycontactsdelegations) | **PUT** /rest/v2/contact/delegations | Update delegations in healthElements.
*ContactApi* | [**newContactDelegations**](doc//ContactApi.md#newcontactdelegations) | **POST** /rest/v2/contact/{contactId}/delegate | Delegates a contact to a healthcare party
*ContactApi* | [**setContactsDelegations**](doc//ContactApi.md#setcontactsdelegations) | **POST** /rest/v2/contact/delegations | Update delegations in healthElements.
*DeviceApi* | [**createDevice**](doc//DeviceApi.md#createdevice) | **POST** /rest/v2/device | Create a device
*DeviceApi* | [**createDevices**](doc//DeviceApi.md#createdevices) | **POST** /rest/v2/device/batch | Create devices in bulk
*DeviceApi* | [**createDevices1**](doc//DeviceApi.md#createdevices1) | **POST** /rest/v2/device/bulk | Create devices in bulk
*DeviceApi* | [**deleteDevice**](doc//DeviceApi.md#deletedevice) | **DELETE** /rest/v2/device/{deviceId} | Delete device.
*DeviceApi* | [**deleteDevices**](doc//DeviceApi.md#deletedevices) | **POST** /rest/v2/device/delete/batch | Delete devices.
*DeviceApi* | [**filterDevicesBy**](doc//DeviceApi.md#filterdevicesby) | **POST** /rest/v2/device/filter | Filter devices for the current user (HcParty) 
*DeviceApi* | [**getDevice**](doc//DeviceApi.md#getdevice) | **GET** /rest/v2/device/{deviceId} | Get Device
*DeviceApi* | [**getDevices**](doc//DeviceApi.md#getdevices) | **POST** /rest/v2/device/byIds | Get devices by id
*DeviceApi* | [**matchDevicesBy**](doc//DeviceApi.md#matchdevicesby) | **POST** /rest/v2/device/match | Get ids of devices matching the provided filter for the current user (HcParty) 
*DeviceApi* | [**updateDevice**](doc//DeviceApi.md#updatedevice) | **PUT** /rest/v2/device | Modify a device
*DeviceApi* | [**updateDevices**](doc//DeviceApi.md#updatedevices) | **PUT** /rest/v2/device/batch | Modify devices in bulk
*DeviceApi* | [**updateDevices1**](doc//DeviceApi.md#updatedevices1) | **PUT** /rest/v2/device/bulk | Modify devices in bulk
*DocumentApi* | [**createDocument**](doc//DocumentApi.md#createdocument) | **POST** /rest/v2/document | Creates a document
*DocumentApi* | [**deleteAttachment**](doc//DocumentApi.md#deleteattachment) | **DELETE** /rest/v2/document/{documentId}/attachment | Deletes a document's attachment
*DocumentApi* | [**deleteDocument**](doc//DocumentApi.md#deletedocument) | **POST** /rest/v2/document/delete/batch | Deletes documents
*DocumentApi* | [**findWithoutDelegation**](doc//DocumentApi.md#findwithoutdelegation) | **GET** /rest/v2/document/woDelegation | List documents with no delegation
*DocumentApi* | [**getDocument**](doc//DocumentApi.md#getdocument) | **GET** /rest/v2/document/{documentId} | Gets a document
*DocumentApi* | [**getDocumentAttachment**](doc//DocumentApi.md#getdocumentattachment) | **GET** /rest/v2/document/{documentId}/attachment/{attachmentId} | Load document's attachment
*DocumentApi* | [**getDocumentByExternalUuid**](doc//DocumentApi.md#getdocumentbyexternaluuid) | **GET** /rest/v2/document/externaluuid/{externalUuid} | Gets a document
*DocumentApi* | [**getDocuments**](doc//DocumentApi.md#getdocuments) | **POST** /rest/v2/document/byIds | Gets a document
*DocumentApi* | [**getDocumentsByExternalUuid**](doc//DocumentApi.md#getdocumentsbyexternaluuid) | **GET** /rest/v2/document/externaluuid/{externalUuid}/all | Get all documents with externalUuid
*DocumentApi* | [**listDocumentByTypeHCPartyMessageSecretFKeys**](doc//DocumentApi.md#listdocumentbytypehcpartymessagesecretfkeys) | **GET** /rest/v2/document/byTypeHcPartySecretForeignKeys | List documents found By type, By Healthcare Party and secret foreign keys.
*DocumentApi* | [**listDocumentsByHCPartyAndPatientForeignKeys**](doc//DocumentApi.md#listdocumentsbyhcpartyandpatientforeignkeys) | **GET** /rest/v2/document/byHcPartySecretForeignKeys | List documents found By Healthcare Party and secret foreign keys.
*DocumentApi* | [**modifyDocument**](doc//DocumentApi.md#modifydocument) | **PUT** /rest/v2/document | Updates a document
*DocumentApi* | [**modifyDocuments**](doc//DocumentApi.md#modifydocuments) | **PUT** /rest/v2/document/batch | Updates a batch of documents
*DocumentApi* | [**setDocumentAttachment**](doc//DocumentApi.md#setdocumentattachment) | **PUT** /rest/v2/document/{documentId}/attachment | Creates a document's attachment
*DocumentApi* | [**setDocumentAttachmentMulti**](doc//DocumentApi.md#setdocumentattachmentmulti) | **PUT** /rest/v2/document/{documentId}/attachment/multipart | Creates a document's attachment
*DocumentApi* | [**setDocumentsDelegations**](doc//DocumentApi.md#setdocumentsdelegations) | **POST** /rest/v2/document/delegations | Update delegations in healthElements.
*DocumentApi* | [**setSafeDocumentAttachment**](doc//DocumentApi.md#setsafedocumentattachment) | **PUT** /rest/v2/document/attachment | Creates a document's attachment
*DocumentTemplateApi* | [**createDocumentTemplate**](doc//DocumentTemplateApi.md#createdocumenttemplate) | **POST** /rest/v2/doctemplate | Create a document template with the current user
*DocumentTemplateApi* | [**deleteDocumentTemplates**](doc//DocumentTemplateApi.md#deletedocumenttemplates) | **POST** /rest/v2/doctemplate/delete/batch | Deletes document templates
*DocumentTemplateApi* | [**getAttachmentText**](doc//DocumentTemplateApi.md#getattachmenttext) | **GET** /rest/v2/doctemplate/{documentTemplateId}/attachmentText/{attachmentId} | Download a the document template attachment
*DocumentTemplateApi* | [**getDocumentTemplate**](doc//DocumentTemplateApi.md#getdocumenttemplate) | **GET** /rest/v2/doctemplate/{documentTemplateId} | Gets a document template
*DocumentTemplateApi* | [**getDocumentTemplateAttachment**](doc//DocumentTemplateApi.md#getdocumenttemplateattachment) | **GET** /rest/v2/doctemplate/{documentTemplateId}/attachment/{attachmentId} | Download a the document template attachment
*DocumentTemplateApi* | [**listAllDocumentTemplates**](doc//DocumentTemplateApi.md#listalldocumenttemplates) | **GET** /rest/v2/doctemplate/find/all | Gets all document templates for all users
*DocumentTemplateApi* | [**listDocumentTemplates**](doc//DocumentTemplateApi.md#listdocumenttemplates) | **GET** /rest/v2/doctemplate | Gets all document templates for current user
*DocumentTemplateApi* | [**listDocumentTemplatesByDocumentType**](doc//DocumentTemplateApi.md#listdocumenttemplatesbydocumenttype) | **GET** /rest/v2/doctemplate/byDocumentType/{documentTypeCode} | Gets all document templates by Type
*DocumentTemplateApi* | [**listDocumentTemplatesByDocumentTypeForCurrentUser**](doc//DocumentTemplateApi.md#listdocumenttemplatesbydocumenttypeforcurrentuser) | **GET** /rest/v2/doctemplate/byDocumentTypeForCurrentUser/{documentTypeCode} | Gets all document templates by Type For currentUser
*DocumentTemplateApi* | [**listDocumentTemplatesBySpeciality**](doc//DocumentTemplateApi.md#listdocumenttemplatesbyspeciality) | **GET** /rest/v2/doctemplate/bySpecialty/{specialityCode} | Gets all document templates
*DocumentTemplateApi* | [**modifyDocumentTemplate**](doc//DocumentTemplateApi.md#modifydocumenttemplate) | **PUT** /rest/v2/doctemplate/{documentTemplateId} | Modify a document template with the current user
*DocumentTemplateApi* | [**setDocumentTemplateAttachment**](doc//DocumentTemplateApi.md#setdocumenttemplateattachment) | **PUT** /rest/v2/doctemplate/{documentTemplateId}/attachment | Creates a document's attachment
*DocumentTemplateApi* | [**setDocumentTemplateAttachmentJson**](doc//DocumentTemplateApi.md#setdocumenttemplateattachmentjson) | **PUT** /rest/v2/doctemplate/{documentTemplateId}/attachmentJson | Creates a document's attachment
*EntityTemplateApi* | [**createEntityTemplate**](doc//EntityTemplateApi.md#createentitytemplate) | **POST** /rest/v2/entitytemplate | Create a EntityTemplate
*EntityTemplateApi* | [**createEntityTemplates**](doc//EntityTemplateApi.md#createentitytemplates) | **POST** /rest/v2/entitytemplate/batch | Create a batch of entityTemplates
*EntityTemplateApi* | [**deleteEntityTemplate**](doc//EntityTemplateApi.md#deleteentitytemplate) | **POST** /rest/v2/entitytemplate/delete/batch | Delete entity templates
*EntityTemplateApi* | [**findAllEntityTemplatesByKeyword**](doc//EntityTemplateApi.md#findallentitytemplatesbykeyword) | **GET** /rest/v2/entitytemplate/findAll/{type}/keyword/{keyword} | Finding entityTemplates by entityTemplate, type and version with pagination.
*EntityTemplateApi* | [**getEntityTemplate**](doc//EntityTemplateApi.md#getentitytemplate) | **GET** /rest/v2/entitytemplate/{entityTemplateId} | Get a entityTemplate
*EntityTemplateApi* | [**getEntityTemplates**](doc//EntityTemplateApi.md#getentitytemplates) | **POST** /rest/v2/entitytemplate/byIds | Get a list of entityTemplates by ids
*EntityTemplateApi* | [**listAllEntityTemplatesBy**](doc//EntityTemplateApi.md#listallentitytemplatesby) | **GET** /rest/v2/entitytemplate/findAll/{type} | Finding entityTemplates by entityTemplate, type and version with pagination.
*EntityTemplateApi* | [**listEntityTemplatesBy**](doc//EntityTemplateApi.md#listentitytemplatesby) | **GET** /rest/v2/entitytemplate/find/{userId}/{type} | Finding entityTemplates by userId, entityTemplate, type and version with pagination.
*EntityTemplateApi* | [**listEntityTemplatesByKeyword**](doc//EntityTemplateApi.md#listentitytemplatesbykeyword) | **GET** /rest/v2/entitytemplate/find/{userId}/{type}/keyword/{keyword} | Finding entityTemplates by userId, type and keyword.
*EntityTemplateApi* | [**modifyEntityTemplate**](doc//EntityTemplateApi.md#modifyentitytemplate) | **PUT** /rest/v2/entitytemplate | Modify a entityTemplate
*EntityTemplateApi* | [**modifyEntityTemplates**](doc//EntityTemplateApi.md#modifyentitytemplates) | **PUT** /rest/v2/entitytemplate/batch | Modify a batch of entityTemplates
*EntityrefApi* | [**createEntityReference**](doc//EntityrefApi.md#createentityreference) | **POST** /rest/v2/entityref | Create an entity reference
*EntityrefApi* | [**getLatest**](doc//EntityrefApi.md#getlatest) | **GET** /rest/v2/entityref/latest/{prefix} | Find latest reference for a prefix 
*FormApi* | [**createForm**](doc//FormApi.md#createform) | **POST** /rest/v2/form | Create a form with the current user
*FormApi* | [**createFormTemplate**](doc//FormApi.md#createformtemplate) | **POST** /rest/v2/form/template | Create a form template with the current user
*FormApi* | [**createForms**](doc//FormApi.md#createforms) | **POST** /rest/v2/form/batch | Create a batch of forms
*FormApi* | [**deleteFormTemplate**](doc//FormApi.md#deleteformtemplate) | **DELETE** /rest/v2/form/template/{formTemplateId} | Delete a form template
*FormApi* | [**deleteForms**](doc//FormApi.md#deleteforms) | **POST** /rest/v2/form/delete/batch | Delete forms.
*FormApi* | [**getChildrenForms**](doc//FormApi.md#getchildrenforms) | **GET** /rest/v2/form/childrenOf/{formId}/{hcPartyId} | Get a list of forms by parents ids
*FormApi* | [**getForm**](doc//FormApi.md#getform) | **GET** /rest/v2/form/{formId} | Gets a form
*FormApi* | [**getFormByLogicalUuid**](doc//FormApi.md#getformbylogicaluuid) | **GET** /rest/v2/form/logicalUuid/{logicalUuid} | Gets the most recent form with the given logicalUuid
*FormApi* | [**getFormByUniqueId**](doc//FormApi.md#getformbyuniqueid) | **GET** /rest/v2/form/uniqueId/{uniqueId} | Gets the most recent form with the given uniqueId
*FormApi* | [**getFormTemplate**](doc//FormApi.md#getformtemplate) | **GET** /rest/v2/form/template/{formTemplateId} | Gets a form template by guid
*FormApi* | [**getFormTemplates**](doc//FormApi.md#getformtemplates) | **GET** /rest/v2/form/template | Gets all form templates for current user
*FormApi* | [**getFormTemplatesByGuid**](doc//FormApi.md#getformtemplatesbyguid) | **GET** /rest/v2/form/template/{specialityCode}/guid/{formTemplateGuid} | Gets a form template
*FormApi* | [**getForms**](doc//FormApi.md#getforms) | **POST** /rest/v2/form/byIds | Get a list of forms by ids
*FormApi* | [**getFormsByLogicalUuid**](doc//FormApi.md#getformsbylogicaluuid) | **GET** /rest/v2/form/all/logicalUuid/{logicalUuid} | Gets all forms with given logicalUuid
*FormApi* | [**getFormsByUniqueId**](doc//FormApi.md#getformsbyuniqueid) | **GET** /rest/v2/form/all/uniqueId/{uniqueId} | Gets all forms by uniqueId
*FormApi* | [**listFormTemplatesBySpeciality**](doc//FormApi.md#listformtemplatesbyspeciality) | **GET** /rest/v2/form/template/bySpecialty/{specialityCode} | Gets all form templates
*FormApi* | [**listFormsByHCPartyAndPatientForeignKeys**](doc//FormApi.md#listformsbyhcpartyandpatientforeignkeys) | **GET** /rest/v2/form/byHcPartySecretForeignKeys | List forms found By Healthcare Party and secret foreign keys.
*FormApi* | [**listFormsDelegationsStubsByHCPartyAndPatientForeignKeys**](doc//FormApi.md#listformsdelegationsstubsbyhcpartyandpatientforeignkeys) | **GET** /rest/v2/form/byHcPartySecretForeignKeys/delegations | List form stubs found By Healthcare Party and secret foreign keys.
*FormApi* | [**modifyForm**](doc//FormApi.md#modifyform) | **PUT** /rest/v2/form | Modify a form
*FormApi* | [**modifyForms**](doc//FormApi.md#modifyforms) | **PUT** /rest/v2/form/batch | Modify a batch of forms
*FormApi* | [**newFormDelegations**](doc//FormApi.md#newformdelegations) | **POST** /rest/v2/form/delegate/{formId} | Delegates a form to a healthcare party
*FormApi* | [**setFormsDelegations**](doc//FormApi.md#setformsdelegations) | **POST** /rest/v2/form/delegations | Update delegations in form.
*FormApi* | [**setTemplateAttachmentMulti**](doc//FormApi.md#settemplateattachmentmulti) | **PUT** /rest/v2/form/template/{formTemplateId}/attachment/multipart | Update a form template's layout
*FormApi* | [**updateFormTemplate**](doc//FormApi.md#updateformtemplate) | **PUT** /rest/v2/form/template/{formTemplateId} | Modify a form template with the current user
*FrontEndMigrationApi* | [**createFrontEndMigration**](doc//FrontEndMigrationApi.md#createfrontendmigration) | **POST** /rest/v2/frontendmigration | Creates a front end migration
*FrontEndMigrationApi* | [**deleteFrontEndMigration**](doc//FrontEndMigrationApi.md#deletefrontendmigration) | **DELETE** /rest/v2/frontendmigration/{frontEndMigrationId} | Deletes a front end migration
*FrontEndMigrationApi* | [**getFrontEndMigration**](doc//FrontEndMigrationApi.md#getfrontendmigration) | **GET** /rest/v2/frontendmigration/{frontEndMigrationId} | Gets a front end migration
*FrontEndMigrationApi* | [**getFrontEndMigrationByName**](doc//FrontEndMigrationApi.md#getfrontendmigrationbyname) | **GET** /rest/v2/frontendmigration/byName/{frontEndMigrationName} | Gets an front end migration
*FrontEndMigrationApi* | [**getFrontEndMigrations**](doc//FrontEndMigrationApi.md#getfrontendmigrations) | **GET** /rest/v2/frontendmigration | Gets a front end migration
*FrontEndMigrationApi* | [**modifyFrontEndMigration**](doc//FrontEndMigrationApi.md#modifyfrontendmigration) | **PUT** /rest/v2/frontendmigration | Modifies a front end migration
*GroupApi* | [**createGroup**](doc//GroupApi.md#creategroup) | **POST** /rest/v2/group/{id} | Create a group
*GroupApi* | [**getGroup**](doc//GroupApi.md#getgroup) | **GET** /rest/v2/group/{id} | Get a group by id
*GroupApi* | [**getReplicationInfo1**](doc//GroupApi.md#getreplicationinfo1) | **GET** /rest/v2/group/{id}/r | Get index info
*GroupApi* | [**initDesignDocs**](doc//GroupApi.md#initdesigndocs) | **PUT** /rest/v2/group/{id}/dd | Init design docs
*GroupApi* | [**listGroups**](doc//GroupApi.md#listgroups) | **GET** /rest/v2/group | List groups
*GroupApi* | [**modifyGroupName**](doc//GroupApi.md#modifygroupname) | **PUT** /rest/v2/group/{id}/name/{name} | Update group name
*GroupApi* | [**modifyGroupProperties**](doc//GroupApi.md#modifygroupproperties) | **PUT** /rest/v2/group/{id}/properties | Update group properties
*GroupApi* | [**registerNewGroupAdministrator**](doc//GroupApi.md#registernewgroupadministrator) | **POST** /rest/v2/group/register/trial | Create a group
*GroupApi* | [**resetStorage**](doc//GroupApi.md#resetstorage) | **POST** /rest/v2/group/{id}/reset/storage | Reset storage for group
*GroupApi* | [**setGroupPassword**](doc//GroupApi.md#setgrouppassword) | **PUT** /rest/v2/group/{id}/password | Set group password
*GroupApi* | [**solveConflicts**](doc//GroupApi.md#solveconflicts) | **POST** /rest/v2/group/{id}/conflicts | Solve conflicts for group
*HealthElementApi* | [**createHealthElement**](doc//HealthElementApi.md#createhealthelement) | **POST** /rest/v2/helement | Create a health element with the current user
*HealthElementApi* | [**createHealthElements**](doc//HealthElementApi.md#createhealthelements) | **POST** /rest/v2/helement/batch | Create a batch of healthcare elements
*HealthElementApi* | [**deleteHealthElements**](doc//HealthElementApi.md#deletehealthelements) | **POST** /rest/v2/helement/delete/batch | Delete health elements.
*HealthElementApi* | [**filterHealthElementsBy**](doc//HealthElementApi.md#filterhealthelementsby) | **POST** /rest/v2/helement/filter | Filter health elements for the current user (HcParty)
*HealthElementApi* | [**getHealthElement**](doc//HealthElementApi.md#gethealthelement) | **GET** /rest/v2/helement/{healthElementId} | Get a health element
*HealthElementApi* | [**getHealthElements**](doc//HealthElementApi.md#gethealthelements) | **POST** /rest/v2/helement/byIds | Get healthElements by batch
*HealthElementApi* | [**listHealthElementsByHCPartyAndPatientForeignKeys**](doc//HealthElementApi.md#listhealthelementsbyhcpartyandpatientforeignkeys) | **GET** /rest/v2/helement/byHcPartySecretForeignKeys | List health elements found By Healthcare Party and secret foreign keyelementIds.
*HealthElementApi* | [**listHealthElementsDelegationsStubsByHCPartyAndPatientForeignKeys**](doc//HealthElementApi.md#listhealthelementsdelegationsstubsbyhcpartyandpatientforeignkeys) | **GET** /rest/v2/helement/byHcPartySecretForeignKeys/delegations | List helement stubs found By Healthcare Party and secret foreign keys.
*HealthElementApi* | [**matchHealthElementsBy**](doc//HealthElementApi.md#matchhealthelementsby) | **POST** /rest/v2/helement/match | Get ids of health element matching the provided filter for the current user (HcParty) 
*HealthElementApi* | [**modifyHealthElement**](doc//HealthElementApi.md#modifyhealthelement) | **PUT** /rest/v2/helement | Modify a health element
*HealthElementApi* | [**modifyHealthElements**](doc//HealthElementApi.md#modifyhealthelements) | **PUT** /rest/v2/helement/batch | Modify a batch of health elements
*HealthElementApi* | [**newHealthElementDelegations**](doc//HealthElementApi.md#newhealthelementdelegations) | **POST** /rest/v2/helement/{healthElementId}/delegate | Delegates a health element to a healthcare party
*HealthElementApi* | [**setHealthElementsDelegations**](doc//HealthElementApi.md#sethealthelementsdelegations) | **POST** /rest/v2/helement/delegations | Update delegations in healthElements.
*HealthcarePartyApi* | [**createHealthcareParty**](doc//HealthcarePartyApi.md#createhealthcareparty) | **POST** /rest/v2/hcparty | Create a healthcare party
*HealthcarePartyApi* | [**createHealthcarePartyInGroup**](doc//HealthcarePartyApi.md#createhealthcarepartyingroup) | **POST** /rest/v2/hcparty/inGroup/{groupId} | Create a healthcare party
*HealthcarePartyApi* | [**deleteHealthcareParties**](doc//HealthcarePartyApi.md#deletehealthcareparties) | **POST** /rest/v2/hcparty/delete/batch | Delete healthcare parties
*HealthcarePartyApi* | [**deleteHealthcarePartiesInGroup**](doc//HealthcarePartyApi.md#deletehealthcarepartiesingroup) | **POST** /rest/v2/hcparty/delete/batch/inGroup/{groupId} | Delete a healthcare party
*HealthcarePartyApi* | [**filterHealthPartiesBy**](doc//HealthcarePartyApi.md#filterhealthpartiesby) | **POST** /rest/v2/hcparty/filter | Filter healthcare parties for the current user (HcParty)
*HealthcarePartyApi* | [**findHealthcarePartiesBy**](doc//HealthcarePartyApi.md#findhealthcarepartiesby) | **GET** /rest/v2/hcparty | List healthcare parties with(out) pagination
*HealthcarePartyApi* | [**findHealthcarePartiesByName**](doc//HealthcarePartyApi.md#findhealthcarepartiesbyname) | **GET** /rest/v2/hcparty/byName | Find healthcare parties by name with(out) pagination
*HealthcarePartyApi* | [**findHealthcarePartiesBySpecialityAndPostCode**](doc//HealthcarePartyApi.md#findhealthcarepartiesbyspecialityandpostcode) | **GET** /rest/v2/hcparty/bySpecialityAndPostCode/{type}/{spec}/{firstCode}/to/{lastCode} | Find healthcare parties by name with(out) pagination
*HealthcarePartyApi* | [**findHealthcarePartiesBySsinOrNihii**](doc//HealthcarePartyApi.md#findhealthcarepartiesbyssinornihii) | **GET** /rest/v2/hcparty/byNihiiOrSsin/{searchValue} | Find healthcare parties by nihii or ssin with(out) pagination
*HealthcarePartyApi* | [**getCurrentHealthcareParty**](doc//HealthcarePartyApi.md#getcurrenthealthcareparty) | **GET** /rest/v2/hcparty/current | Get the current healthcare party if logged in.
*HealthcarePartyApi* | [**getHcPartyKeysForDelegate**](doc//HealthcarePartyApi.md#gethcpartykeysfordelegate) | **GET** /rest/v2/hcparty/byKeys/{healthcarePartyId} | Get the HcParty encrypted AES keys indexed by owner
*HealthcarePartyApi* | [**getHealthcareParties**](doc//HealthcarePartyApi.md#gethealthcareparties) | **POST** /rest/v2/hcparty/byIds | Get healthcareParties by their IDs
*HealthcarePartyApi* | [**getHealthcareParty**](doc//HealthcarePartyApi.md#gethealthcareparty) | **GET** /rest/v2/hcparty/{healthcarePartyId} | Get a healthcareParty by his ID
*HealthcarePartyApi* | [**getPublicKey**](doc//HealthcarePartyApi.md#getpublickey) | **GET** /rest/v2/hcparty/{healthcarePartyId}/publicKey | Get public key of a healthcare party
*HealthcarePartyApi* | [**listHealthcarePartiesByName**](doc//HealthcarePartyApi.md#listhealthcarepartiesbyname) | **GET** /rest/v2/hcparty/byNameStrict/{name} | Find healthcare parties by name with(out) pagination
*HealthcarePartyApi* | [**listHealthcarePartiesByParentId**](doc//HealthcarePartyApi.md#listhealthcarepartiesbyparentid) | **GET** /rest/v2/hcparty/{parentId}/children | Find children of an healthcare parties
*HealthcarePartyApi* | [**matchHealthcarePartiesBy**](doc//HealthcarePartyApi.md#matchhealthcarepartiesby) | **POST** /rest/v2/hcparty/match | Get ids of healthcare party matching the provided filter for the current user (HcParty) 
*HealthcarePartyApi* | [**modifyHealthcareParty**](doc//HealthcarePartyApi.md#modifyhealthcareparty) | **PUT** /rest/v2/hcparty | Modify a Healthcare Party.
*HealthcarePartyApi* | [**modifyHealthcarePartyInGroup**](doc//HealthcarePartyApi.md#modifyhealthcarepartyingroup) | **PUT** /rest/v2/hcparty/inGroup/{groupId} | Modify a Healthcare Party.
*IcureApi* | [**getIndexingInfo**](doc//IcureApi.md#getindexinginfo) | **GET** /rest/v2/icure/i | Get index info
*IcureApi* | [**getProcessInfo**](doc//IcureApi.md#getprocessinfo) | **GET** /rest/v2/icure/p | Get process info
*IcureApi* | [**getReplicationInfo**](doc//IcureApi.md#getreplicationinfo) | **GET** /rest/v2/icure/r | Get replication info
*IcureApi* | [**getReplicatorInfo**](doc//IcureApi.md#getreplicatorinfo) | **GET** /rest/v2/icure/r/{id} | Get replication info
*IcureApi* | [**getVersion**](doc//IcureApi.md#getversion) | **GET** /rest/v2/icure/v | Get version
*IcureApi* | [**isReady**](doc//IcureApi.md#isready) | **GET** /rest/v2/icure/ok | Check if a user exists
*IcureApi* | [**resolveContactsConflicts**](doc//IcureApi.md#resolvecontactsconflicts) | **POST** /rest/v2/icure/conflicts/contact | Resolve contacts conflicts
*IcureApi* | [**resolveDocumentsConflicts**](doc//IcureApi.md#resolvedocumentsconflicts) | **POST** /rest/v2/icure/conflicts/document | resolve documents conflicts
*IcureApi* | [**resolveFormsConflicts**](doc//IcureApi.md#resolveformsconflicts) | **POST** /rest/v2/icure/conflicts/form | resolve forms conflicts
*IcureApi* | [**resolveHealthElementsConflicts**](doc//IcureApi.md#resolvehealthelementsconflicts) | **POST** /rest/v2/icure/conflicts/healthelement | resolve healthcare elements conflicts
*IcureApi* | [**resolveInvoicesConflicts**](doc//IcureApi.md#resolveinvoicesconflicts) | **POST** /rest/v2/icure/conflicts/invoice | resolve invoices conflicts
*IcureApi* | [**resolveMessagesConflicts**](doc//IcureApi.md#resolvemessagesconflicts) | **POST** /rest/v2/icure/conflicts/message | resolve messages conflicts
*IcureApi* | [**resolvePatientsConflicts**](doc//IcureApi.md#resolvepatientsconflicts) | **POST** /rest/v2/icure/conflicts/patient | Resolve patients conflicts
*IcureApi* | [**updateDesignDoc**](doc//IcureApi.md#updatedesigndoc) | **POST** /rest/v2/icure/dd/{entityName} | Force update design doc
*InsuranceApi* | [**createInsurance**](doc//InsuranceApi.md#createinsurance) | **POST** /rest/v2/insurance | Creates an insurance
*InsuranceApi* | [**deleteInsurance**](doc//InsuranceApi.md#deleteinsurance) | **DELETE** /rest/v2/insurance/{insuranceId} | Deletes an insurance
*InsuranceApi* | [**getInsurance**](doc//InsuranceApi.md#getinsurance) | **GET** /rest/v2/insurance/{insuranceId} | Gets an insurance
*InsuranceApi* | [**getInsurances**](doc//InsuranceApi.md#getinsurances) | **POST** /rest/v2/insurance/byIds | Gets insurances by id
*InsuranceApi* | [**listInsurancesByCode**](doc//InsuranceApi.md#listinsurancesbycode) | **GET** /rest/v2/insurance/byCode/{insuranceCode} | Gets an insurance
*InsuranceApi* | [**listInsurancesByName**](doc//InsuranceApi.md#listinsurancesbyname) | **GET** /rest/v2/insurance/byName/{insuranceName} | Gets an insurance
*InsuranceApi* | [**modifyInsurance**](doc//InsuranceApi.md#modifyinsurance) | **PUT** /rest/v2/insurance | Modifies an insurance
*InvoiceApi* | [**appendCodes**](doc//InvoiceApi.md#appendcodes) | **POST** /rest/v2/invoice/byauthor/{userId}/append/{type}/{sentMediumType} | Gets all invoices for author at date
*InvoiceApi* | [**createInvoice**](doc//InvoiceApi.md#createinvoice) | **POST** /rest/v2/invoice | Creates an invoice
*InvoiceApi* | [**createInvoices**](doc//InvoiceApi.md#createinvoices) | **POST** /rest/v2/invoice/batch | Create a batch of invoices
*InvoiceApi* | [**deleteInvoice**](doc//InvoiceApi.md#deleteinvoice) | **DELETE** /rest/v2/invoice/{invoiceId} | Deletes an invoice
*InvoiceApi* | [**filterInvoicesBy**](doc//InvoiceApi.md#filterinvoicesby) | **POST** /rest/v2/invoice/filter | Filter invoices for the current user (HcParty)
*InvoiceApi* | [**findInvoicesByAuthor**](doc//InvoiceApi.md#findinvoicesbyauthor) | **GET** /rest/v2/invoice/byauthor/{hcPartyId} | Gets all invoices for author at date
*InvoiceApi* | [**getInvoice**](doc//InvoiceApi.md#getinvoice) | **GET** /rest/v2/invoice/{invoiceId} | Gets an invoice
*InvoiceApi* | [**getInvoices**](doc//InvoiceApi.md#getinvoices) | **POST** /rest/v2/invoice/byIds | Gets an invoice
*InvoiceApi* | [**getTarificationsCodesOccurences**](doc//InvoiceApi.md#gettarificationscodesoccurences) | **GET** /rest/v2/invoice/codes/{minOccurences} | Get the list of all used tarifications frequencies in invoices
*InvoiceApi* | [**listAllHcpsByStatus**](doc//InvoiceApi.md#listallhcpsbystatus) | **POST** /rest/v2/invoice/allHcpsByStatus/{status} | Gets all invoices per status
*InvoiceApi* | [**listInvoicesByContactIds**](doc//InvoiceApi.md#listinvoicesbycontactids) | **POST** /rest/v2/invoice/byContacts | Gets all invoices for author at date
*InvoiceApi* | [**listInvoicesByHCPartyAndPatientForeignKeys**](doc//InvoiceApi.md#listinvoicesbyhcpartyandpatientforeignkeys) | **GET** /rest/v2/invoice/byHcPartySecretForeignKeys | List invoices found By Healthcare Party and secret foreign patient keys.
*InvoiceApi* | [**listInvoicesByHcPartyAndGroupId**](doc//InvoiceApi.md#listinvoicesbyhcpartyandgroupid) | **GET** /rest/v2/invoice/byHcPartyGroupId/{hcPartyId}/{groupId} | List invoices by groupId
*InvoiceApi* | [**listInvoicesByHcPartySentMediumTypeInvoiceTypeSentDate**](doc//InvoiceApi.md#listinvoicesbyhcpartysentmediumtypeinvoicetypesentdate) | **GET** /rest/v2/invoice/byHcParty/{hcPartyId}/mediumType/{sentMediumType}/invoiceType/{invoiceType}/sent/{sent} | List invoices by type, sent or unsent
*InvoiceApi* | [**listInvoicesByHcpartySendingModeStatusDate**](doc//InvoiceApi.md#listinvoicesbyhcpartysendingmodestatusdate) | **GET** /rest/v2/invoice/byHcpartySendingModeStatusDate/{hcPartyId} | Get all invoices by author, by sending mode, by status and by date
*InvoiceApi* | [**listInvoicesByIds**](doc//InvoiceApi.md#listinvoicesbyids) | **GET** /rest/v2/invoice/byIds/{invoiceIds} | Gets all invoices for author at date
*InvoiceApi* | [**listInvoicesByRecipientsIds**](doc//InvoiceApi.md#listinvoicesbyrecipientsids) | **GET** /rest/v2/invoice/to/{recipientIds} | Gets all invoices for author at date
*InvoiceApi* | [**listInvoicesByServiceIds**](doc//InvoiceApi.md#listinvoicesbyserviceids) | **GET** /rest/v2/invoice/byServiceIds/{serviceIds} | Gets all invoices for author at date
*InvoiceApi* | [**listInvoicesDelegationsStubsByHCPartyAndPatientForeignKeys**](doc//InvoiceApi.md#listinvoicesdelegationsstubsbyhcpartyandpatientforeignkeys) | **GET** /rest/v2/invoice/byHcPartySecretForeignKeys/delegations | List helement stubs found By Healthcare Party and secret foreign keys.
*InvoiceApi* | [**listToInsurances**](doc//InvoiceApi.md#listtoinsurances) | **GET** /rest/v2/invoice/toInsurances | Gets all invoices for author at date
*InvoiceApi* | [**listToInsurancesUnsent**](doc//InvoiceApi.md#listtoinsurancesunsent) | **GET** /rest/v2/invoice/toInsurances/unsent | Gets all invoices for author at date
*InvoiceApi* | [**listToPatients**](doc//InvoiceApi.md#listtopatients) | **GET** /rest/v2/invoice/toPatients | Gets all invoices for author at date
*InvoiceApi* | [**listToPatientsUnsent**](doc//InvoiceApi.md#listtopatientsunsent) | **GET** /rest/v2/invoice/toPatients/unsent | Gets all invoices for author at date
*InvoiceApi* | [**mergeTo**](doc//InvoiceApi.md#mergeto) | **POST** /rest/v2/invoice/mergeTo/{invoiceId} | Gets all invoices for author at date
*InvoiceApi* | [**modifyInvoice**](doc//InvoiceApi.md#modifyinvoice) | **PUT** /rest/v2/invoice | Modifies an invoice
*InvoiceApi* | [**modifyInvoices**](doc//InvoiceApi.md#modifyinvoices) | **PUT** /rest/v2/invoice/batch | Modify a batch of invoices
*InvoiceApi* | [**newInvoiceDelegations**](doc//InvoiceApi.md#newinvoicedelegations) | **PUT** /rest/v2/invoice/{invoiceId}/delegate | Adds a delegation to a invoice
*InvoiceApi* | [**reassignInvoice**](doc//InvoiceApi.md#reassigninvoice) | **POST** /rest/v2/invoice/reassign | Modifies an invoice
*InvoiceApi* | [**removeCodes**](doc//InvoiceApi.md#removecodes) | **POST** /rest/v2/invoice/byauthor/{userId}/service/{serviceId} | Remove an invoice of an user
*InvoiceApi* | [**setInvoicesDelegations**](doc//InvoiceApi.md#setinvoicesdelegations) | **POST** /rest/v2/invoice/delegations | Update delegations in healthElements.
*InvoiceApi* | [**validate**](doc//InvoiceApi.md#validate) | **POST** /rest/v2/invoice/validate/{invoiceId} | Gets all invoices for author at date
*KeywordApi* | [**createKeyword**](doc//KeywordApi.md#createkeyword) | **POST** /rest/v2/keyword | Create a keyword with the current user
*KeywordApi* | [**deleteKeywords**](doc//KeywordApi.md#deletekeywords) | **POST** /rest/v2/keyword/delete/batch | Delete keywords.
*KeywordApi* | [**getKeyword**](doc//KeywordApi.md#getkeyword) | **GET** /rest/v2/keyword/{keywordId} | Get a keyword
*KeywordApi* | [**getKeywords**](doc//KeywordApi.md#getkeywords) | **GET** /rest/v2/keyword | Gets all keywords
*KeywordApi* | [**getKeywordsByUser**](doc//KeywordApi.md#getkeywordsbyuser) | **GET** /rest/v2/keyword/byUser/{userId} | Get keywords by user
*KeywordApi* | [**modifyKeyword**](doc//KeywordApi.md#modifykeyword) | **PUT** /rest/v2/keyword | Modify a keyword
*MedexApi* | [**generateMedex**](doc//MedexApi.md#generatemedex) | **POST** /rest/v2/medex/generate | Generate a Medex XML String
*MedicalLocationApi* | [**createMedicalLocation**](doc//MedicalLocationApi.md#createmedicallocation) | **POST** /rest/v2/medicallocation | Creates a medical location
*MedicalLocationApi* | [**deleteMedicalLocations**](doc//MedicalLocationApi.md#deletemedicallocations) | **POST** /rest/v2/medicallocation/delete/batch | Deletes medical locations
*MedicalLocationApi* | [**getMedicalLocation**](doc//MedicalLocationApi.md#getmedicallocation) | **GET** /rest/v2/medicallocation/{locationId} | Gets a medical location
*MedicalLocationApi* | [**getMedicalLocations**](doc//MedicalLocationApi.md#getmedicallocations) | **GET** /rest/v2/medicallocation | Gets all medical locations
*MedicalLocationApi* | [**modifyMedicalLocation**](doc//MedicalLocationApi.md#modifymedicallocation) | **PUT** /rest/v2/medicallocation | Modifies a medical location
*MessageApi* | [**createMessage**](doc//MessageApi.md#createmessage) | **POST** /rest/v2/message | Creates a message
*MessageApi* | [**deleteDelegation**](doc//MessageApi.md#deletedelegation) | **DELETE** /rest/v2/message/{messageId}/delegate/{delegateId} | Deletes a message delegation
*MessageApi* | [**deleteMessages**](doc//MessageApi.md#deletemessages) | **POST** /rest/v2/message/delete/batch | Deletes multiple messages
*MessageApi* | [**findMessages**](doc//MessageApi.md#findmessages) | **GET** /rest/v2/message | Get all messages (paginated) for current HC Party
*MessageApi* | [**findMessagesByFromAddress**](doc//MessageApi.md#findmessagesbyfromaddress) | **GET** /rest/v2/message/byFromAddress | Get all messages (paginated) for current HC Party and provided from address
*MessageApi* | [**findMessagesByHCPartyPatientForeignKeys**](doc//MessageApi.md#findmessagesbyhcpartypatientforeignkeys) | **GET** /rest/v2/message/byHcPartySecretForeignKeys | List messages found By Healthcare Party and secret foreign keys.
*MessageApi* | [**findMessagesByToAddress**](doc//MessageApi.md#findmessagesbytoaddress) | **GET** /rest/v2/message/byToAddress | Get all messages (paginated) for current HC Party and provided to address
*MessageApi* | [**findMessagesByTransportGuid**](doc//MessageApi.md#findmessagesbytransportguid) | **GET** /rest/v2/message/byTransportGuid | Get all messages (paginated) for current HC Party and provided transportGuid
*MessageApi* | [**findMessagesByTransportGuidSentDate**](doc//MessageApi.md#findmessagesbytransportguidsentdate) | **GET** /rest/v2/message/byTransportGuidSentDate | Get all messages starting by a prefix between two date
*MessageApi* | [**getChildrenMessages**](doc//MessageApi.md#getchildrenmessages) | **GET** /rest/v2/message/{messageId}/children | Get children messages of provided message
*MessageApi* | [**getMessage**](doc//MessageApi.md#getmessage) | **GET** /rest/v2/message/{messageId} | Gets a message
*MessageApi* | [**getMessagesChildren**](doc//MessageApi.md#getmessageschildren) | **POST** /rest/v2/message/children/batch | Get children messages of provided message
*MessageApi* | [**listMessagesByInvoices**](doc//MessageApi.md#listmessagesbyinvoices) | **POST** /rest/v2/message/byInvoice | Get children messages of provided message
*MessageApi* | [**listMessagesByTransportGuids**](doc//MessageApi.md#listmessagesbytransportguids) | **POST** /rest/v2/message/byTransportGuid/list | Get all messages for current HC Party and provided transportGuids
*MessageApi* | [**modifyMessage**](doc//MessageApi.md#modifymessage) | **PUT** /rest/v2/message | Updates a message
*MessageApi* | [**newMessageDelegations**](doc//MessageApi.md#newmessagedelegations) | **PUT** /rest/v2/message/{messageId}/delegate | Adds a delegation to a message
*MessageApi* | [**setMessagesReadStatus**](doc//MessageApi.md#setmessagesreadstatus) | **PUT** /rest/v2/message/readstatus | Set read status for given list of messages
*MessageApi* | [**setMessagesStatusBits**](doc//MessageApi.md#setmessagesstatusbits) | **PUT** /rest/v2/message/status/{status} | Set status bits for given list of messages
*PatientApi* | [**countOfPatients**](doc//PatientApi.md#countofpatients) | **GET** /rest/v2/patient/hcParty/{hcPartyId}/count | Get count of patients for a specific HcParty or for the current HcParty 
*PatientApi* | [**createPatient**](doc//PatientApi.md#createpatient) | **POST** /rest/v2/patient | Create a patient
*PatientApi* | [**createPatients**](doc//PatientApi.md#createpatients) | **POST** /rest/v2/patient/batch | Create patients in bulk
*PatientApi* | [**deletePatients**](doc//PatientApi.md#deletepatients) | **POST** /rest/v2/patient/delete/batch | Delete patients.
*PatientApi* | [**filterPatientsBy**](doc//PatientApi.md#filterpatientsby) | **POST** /rest/v2/patient/filter | Filter patients for the current user (HcParty) 
*PatientApi* | [**findDeletedPatients**](doc//PatientApi.md#finddeletedpatients) | **GET** /rest/v2/patient/deleted/byDate | Find deleted patients
*PatientApi* | [**findDuplicatesByName**](doc//PatientApi.md#findduplicatesbyname) | **POST** /rest/v2/patient/duplicates/name | Provides a paginated list of patients with duplicate name for an hecparty
*PatientApi* | [**findDuplicatesBySsin**](doc//PatientApi.md#findduplicatesbyssin) | **POST** /rest/v2/patient/duplicates/ssin | Provides a paginated list of patients with duplicate ssin for an hecparty
*PatientApi* | [**findPatientsByAccessLogUserAfterDate**](doc//PatientApi.md#findpatientsbyaccessloguserafterdate) | **GET** /rest/v2/patient/byAccess/{userId} | Get Paginated List of Patients sorted by Access logs descending
*PatientApi* | [**findPatientsByHealthcareParty**](doc//PatientApi.md#findpatientsbyhealthcareparty) | **GET** /rest/v2/patient | List patients for a specific HcParty
*PatientApi* | [**findPatientsByNameBirthSsinAuto**](doc//PatientApi.md#findpatientsbynamebirthssinauto) | **GET** /rest/v2/patient/byNameBirthSsinAuto | Find patients for the current user (HcParty) 
*PatientApi* | [**findPatientsIdsByHealthcareParty**](doc//PatientApi.md#findpatientsidsbyhealthcareparty) | **GET** /rest/v2/patient/byHcPartyId | List patients by pages for a specific HcParty
*PatientApi* | [**findPatientsModifiedAfter**](doc//PatientApi.md#findpatientsmodifiedafter) | **GET** /rest/v2/patient/modifiedAfter/{date} | List patients that have been modified after the provided date
*PatientApi* | [**fuzzySearch**](doc//PatientApi.md#fuzzysearch) | **GET** /rest/v2/patient/fuzzy | Filter patients for the current user (HcParty) 
*PatientApi* | [**getPatient**](doc//PatientApi.md#getpatient) | **GET** /rest/v2/patient/{patientId} | Get patient
*PatientApi* | [**getPatientByExternalId**](doc//PatientApi.md#getpatientbyexternalid) | **GET** /rest/v2/patient/byExternalId/{externalId} | Get the patient having the provided externalId
*PatientApi* | [**getPatientByHealthcarepartyAndIdentifier**](doc//PatientApi.md#getpatientbyhealthcarepartyandidentifier) | **GET** /rest/v2/patient/{hcPartyId}/{id} | Get patient by identifier
*PatientApi* | [**getPatientHcPartyKeysForDelegate**](doc//PatientApi.md#getpatienthcpartykeysfordelegate) | **GET** /rest/v2/patient/{patientId}/keys | Get the patient (identified by patientId) hcparty keys. Those keys are AES keys (encrypted) used to share information between HCPs and a patient.
*PatientApi* | [**getPatients**](doc//PatientApi.md#getpatients) | **POST** /rest/v2/patient/byIds | Get patients by id
*PatientApi* | [**listDeletedPatientsByName**](doc//PatientApi.md#listdeletedpatientsbyname) | **GET** /rest/v2/patient/deleted/by_name | Find deleted patients
*PatientApi* | [**listOfMergesAfter**](doc//PatientApi.md#listofmergesafter) | **GET** /rest/v2/patient/merges/{date} | List patients that have been merged towards another patient 
*PatientApi* | [**matchPatientsBy**](doc//PatientApi.md#matchpatientsby) | **POST** /rest/v2/patient/match | Get ids of patients matching the provided filter for the current user (HcParty) 
*PatientApi* | [**mergeInto**](doc//PatientApi.md#mergeinto) | **PUT** /rest/v2/patient/mergeInto/{toId}/from/{fromIds} | Merge a series of patients into another patient
*PatientApi* | [**modifyPatient**](doc//PatientApi.md#modifypatient) | **PUT** /rest/v2/patient | Modify a patient
*PatientApi* | [**modifyPatientReferral**](doc//PatientApi.md#modifypatientreferral) | **PUT** /rest/v2/patient/{patientId}/referral/{referralId} | Set a patient referral doctor
*PatientApi* | [**modifyPatients**](doc//PatientApi.md#modifypatients) | **PUT** /rest/v2/patient/batch | Modify patients in bulk
*PatientApi* | [**newPatientDelegations**](doc//PatientApi.md#newpatientdelegations) | **POST** /rest/v2/patient/{patientId}/delegate | Delegates a patients to a healthcare party
*PatientApi* | [**registerPatient**](doc//PatientApi.md#registerpatient) | **POST** /rest/v2/patient/register/forHcp/{hcPartyId}/inGroup/{groupId} | Register a patient
*PatientApi* | [**undeletePatient**](doc//PatientApi.md#undeletepatient) | **PUT** /rest/v2/patient/undelete/{patientIds} | undelete previously deleted patients
*PermissionApi* | [**modifyUserPermissions**](doc//PermissionApi.md#modifyuserpermissions) | **PUT** /rest/v2/permissions/{userId} | Add / Revoke permissions to user
*PlaceApi* | [**createPlace**](doc//PlaceApi.md#createplace) | **POST** /rest/v2/place | Creates a place
*PlaceApi* | [**deletePlaces**](doc//PlaceApi.md#deleteplaces) | **POST** /rest/v2/place/delete/batch | Deletes places
*PlaceApi* | [**getPlace**](doc//PlaceApi.md#getplace) | **GET** /rest/v2/place/{placeId} | Gets an place
*PlaceApi* | [**getPlaces**](doc//PlaceApi.md#getplaces) | **GET** /rest/v2/place | Gets all places
*PlaceApi* | [**modifyPlace**](doc//PlaceApi.md#modifyplace) | **PUT** /rest/v2/place | Modifies an place
*ReceiptApi* | [**createReceipt**](doc//ReceiptApi.md#createreceipt) | **POST** /rest/v2/receipt | Creates a receipt
*ReceiptApi* | [**deleteReceipts**](doc//ReceiptApi.md#deletereceipts) | **POST** /rest/v2/receipt/delete/batch | Deletes receipts
*ReceiptApi* | [**getReceipt**](doc//ReceiptApi.md#getreceipt) | **GET** /rest/v2/receipt/{receiptId} | Gets a receipt
*ReceiptApi* | [**getReceiptAttachment**](doc//ReceiptApi.md#getreceiptattachment) | **GET** /rest/v2/receipt/{receiptId}/attachment/{attachmentId} | Get an attachment
*ReceiptApi* | [**listByReference**](doc//ReceiptApi.md#listbyreference) | **GET** /rest/v2/receipt/byRef/{ref} | Gets a receipt
*ReceiptApi* | [**modifyReceipt**](doc//ReceiptApi.md#modifyreceipt) | **PUT** /rest/v2/receipt | Updates a receipt
*ReceiptApi* | [**setReceiptAttachment**](doc//ReceiptApi.md#setreceiptattachment) | **PUT** /rest/v2/receipt/{receiptId}/attachment/{blobType} | Creates a receipt's attachment
*TarificationApi* | [**createTarification**](doc//TarificationApi.md#createtarification) | **POST** /rest/v2/tarification | Create a Tarification
*TarificationApi* | [**findTarificationsBy**](doc//TarificationApi.md#findtarificationsby) | **GET** /rest/v2/tarification | Finding tarifications by tarification, type and version with pagination.
*TarificationApi* | [**findTarificationsBy1**](doc//TarificationApi.md#findtarificationsby1) | **GET** /rest/v2/tarification/byRegionTypeTarification | Finding tarifications by tarification, type and version
*TarificationApi* | [**findTarificationsByLabel**](doc//TarificationApi.md#findtarificationsbylabel) | **GET** /rest/v2/tarification/byLabel | Finding tarifications by tarification, type and version with pagination.
*TarificationApi* | [**getTarification**](doc//TarificationApi.md#gettarification) | **GET** /rest/v2/tarification/{tarificationId} | Get a tarification
*TarificationApi* | [**getTarificationWithParts**](doc//TarificationApi.md#gettarificationwithparts) | **GET** /rest/v2/tarification/{type}/{tarification}/{version} | Get a tarification
*TarificationApi* | [**getTarifications**](doc//TarificationApi.md#gettarifications) | **POST** /rest/v2/tarification/byIds | Get a list of tarifications by ids
*TarificationApi* | [**modifyTarification**](doc//TarificationApi.md#modifytarification) | **PUT** /rest/v2/tarification | Modify a tarification
*TimeTableApi* | [**createTimeTable**](doc//TimeTableApi.md#createtimetable) | **POST** /rest/v2/timeTable | Creates a timeTable
*TimeTableApi* | [**deleteTimeTable**](doc//TimeTableApi.md#deletetimetable) | **POST** /rest/v2/timeTable/delete/batch | Deletes an timeTable
*TimeTableApi* | [**getTimeTable**](doc//TimeTableApi.md#gettimetable) | **GET** /rest/v2/timeTable/{timeTableId} | Gets a timeTable
*TimeTableApi* | [**getTimeTablesByAgendaId**](doc//TimeTableApi.md#gettimetablesbyagendaid) | **POST** /rest/v2/timeTable/byAgendaId | Get TimeTables by AgendaId
*TimeTableApi* | [**getTimeTablesByPeriodAndAgendaId**](doc//TimeTableApi.md#gettimetablesbyperiodandagendaid) | **POST** /rest/v2/timeTable/byPeriodAndAgendaId | Get TimeTables by Period and AgendaId
*TimeTableApi* | [**modifyTimeTable**](doc//TimeTableApi.md#modifytimetable) | **PUT** /rest/v2/timeTable | Modifies an timeTable
*TmpApi* | [**createTmpClassification**](doc//TmpApi.md#createtmpclassification) | **POST** /rest/v2/tmp/classification | Create a classification with the current user
*TmpApi* | [**createTmpClassifications**](doc//TmpApi.md#createtmpclassifications) | **POST** /rest/v2/tmp/classification/batch | Create a classification with the current user
*TmpApi* | [**createTmpContact**](doc//TmpApi.md#createtmpcontact) | **POST** /rest/v2/tmp/contact | Create a contact with the current user
*TmpApi* | [**createTmpContacts**](doc//TmpApi.md#createtmpcontacts) | **POST** /rest/v2/tmp/contact/batch | Create a contact with the current user
*TmpApi* | [**createTmpDatabase**](doc//TmpApi.md#createtmpdatabase) | **POST** /rest/v2/tmp | Create tmp database for current user
*TmpApi* | [**createTmpDocument**](doc//TmpApi.md#createtmpdocument) | **POST** /rest/v2/tmp/document | Create a document with the current user
*TmpApi* | [**createTmpDocuments**](doc//TmpApi.md#createtmpdocuments) | **POST** /rest/v2/tmp/document/batch | Create a document with the current user
*TmpApi* | [**createTmpEntityTemplate**](doc//TmpApi.md#createtmpentitytemplate) | **POST** /rest/v2/tmp/entityTemplate | Create a entityTemplate with the current user
*TmpApi* | [**createTmpEntityTemplates**](doc//TmpApi.md#createtmpentitytemplates) | **POST** /rest/v2/tmp/entityTemplate/batch | Create a entityTemplate with the current user
*TmpApi* | [**createTmpForm**](doc//TmpApi.md#createtmpform) | **POST** /rest/v2/tmp/form | Create a form with the current user
*TmpApi* | [**createTmpForms**](doc//TmpApi.md#createtmpforms) | **POST** /rest/v2/tmp/form/batch | Create a form with the current user
*TmpApi* | [**createTmpHealthElement**](doc//TmpApi.md#createtmphealthelement) | **POST** /rest/v2/tmp/healthElement | Create a healthElement with the current user
*TmpApi* | [**createTmpHealthElements**](doc//TmpApi.md#createtmphealthelements) | **POST** /rest/v2/tmp/healthElement/batch | Create a healthElement with the current user
*TmpApi* | [**createTmpInvoice**](doc//TmpApi.md#createtmpinvoice) | **POST** /rest/v2/tmp/invoice | Create a invoice with the current user
*TmpApi* | [**createTmpInvoices**](doc//TmpApi.md#createtmpinvoices) | **POST** /rest/v2/tmp/invoice/batch | Create a invoice with the current user
*TmpApi* | [**createTmpMessage**](doc//TmpApi.md#createtmpmessage) | **POST** /rest/v2/tmp/message | Create a message with the current user
*TmpApi* | [**createTmpMessages**](doc//TmpApi.md#createtmpmessages) | **POST** /rest/v2/tmp/message/batch | Create a message with the current user
*TmpApi* | [**createTmpPatient**](doc//TmpApi.md#createtmppatient) | **POST** /rest/v2/tmp/patient | Create a patient with the current user
*TmpApi* | [**createTmpPatients**](doc//TmpApi.md#createtmppatients) | **POST** /rest/v2/tmp/patient/batch | Create a patient with the current user
*TmpApi* | [**deleteTmpItems**](doc//TmpApi.md#deletetmpitems) | **POST** /rest/v2/tmp/batch/delete | Soft delete items.
*TmpApi* | [**destroyTmpDatabase**](doc//TmpApi.md#destroytmpdatabase) | **DELETE** /rest/v2/tmp | Destroy tmp database for current user
*TmpApi* | [**getTmpClassification**](doc//TmpApi.md#gettmpclassification) | **GET** /rest/v2/tmp/classification/byId/{id} | Get a classification by id
*TmpApi* | [**getTmpClassifications**](doc//TmpApi.md#gettmpclassifications) | **POST** /rest/v2/tmp/classification/get | Get classifications by ids with the current user
*TmpApi* | [**getTmpContact**](doc//TmpApi.md#gettmpcontact) | **GET** /rest/v2/tmp/contact/byId/{id} | Get a contact by id
*TmpApi* | [**getTmpContacts**](doc//TmpApi.md#gettmpcontacts) | **POST** /rest/v2/tmp/contact/get | Get contacts by ids with the current user
*TmpApi* | [**getTmpDocument**](doc//TmpApi.md#gettmpdocument) | **GET** /rest/v2/tmp/document/byId/{id} | Get a document by id
*TmpApi* | [**getTmpDocuments**](doc//TmpApi.md#gettmpdocuments) | **POST** /rest/v2/tmp/document/get | Get documents by ids with the current user
*TmpApi* | [**getTmpEntityTemplate**](doc//TmpApi.md#gettmpentitytemplate) | **GET** /rest/v2/tmp/entityTemplate/byId/{id} | Get a entityTemplate by id
*TmpApi* | [**getTmpEntityTemplates**](doc//TmpApi.md#gettmpentitytemplates) | **POST** /rest/v2/tmp/entityTemplate/get | Get entityTemplates by ids with the current user
*TmpApi* | [**getTmpForm**](doc//TmpApi.md#gettmpform) | **GET** /rest/v2/tmp/form/byId/{id} | Get a form by id
*TmpApi* | [**getTmpForms**](doc//TmpApi.md#gettmpforms) | **POST** /rest/v2/tmp/form/get | Get forms by ids with the current user
*TmpApi* | [**getTmpHealthElement**](doc//TmpApi.md#gettmphealthelement) | **GET** /rest/v2/tmp/healthElement/byId/{id} | Get a healthElement by id
*TmpApi* | [**getTmpHealthElements**](doc//TmpApi.md#gettmphealthelements) | **POST** /rest/v2/tmp/healthElement/get | Get healthElements by ids with the current user
*TmpApi* | [**getTmpInvoice**](doc//TmpApi.md#gettmpinvoice) | **GET** /rest/v2/tmp/invoice/byId/{id} | Get a invoice by id
*TmpApi* | [**getTmpInvoices**](doc//TmpApi.md#gettmpinvoices) | **POST** /rest/v2/tmp/invoice/get | Get invoices by ids with the current user
*TmpApi* | [**getTmpMessage**](doc//TmpApi.md#gettmpmessage) | **GET** /rest/v2/tmp/message/byId/{id} | Get a message by id
*TmpApi* | [**getTmpMessages**](doc//TmpApi.md#gettmpmessages) | **POST** /rest/v2/tmp/message/get | Get messages by ids with the current user
*TmpApi* | [**getTmpPatient**](doc//TmpApi.md#gettmppatient) | **GET** /rest/v2/tmp/patient/byId/{id} | Get a patient by id
*TmpApi* | [**getTmpPatients**](doc//TmpApi.md#gettmppatients) | **POST** /rest/v2/tmp/patient/get | Get patients by ids with the current user
*TmpApi* | [**listTmpClassifications**](doc//TmpApi.md#listtmpclassifications) | **GET** /rest/v2/tmp/classification/list | List classifications with the current user
*TmpApi* | [**listTmpContacts**](doc//TmpApi.md#listtmpcontacts) | **GET** /rest/v2/tmp/contact/list | List contacts with the current user
*TmpApi* | [**listTmpDocuments**](doc//TmpApi.md#listtmpdocuments) | **GET** /rest/v2/tmp/document/list | List documents with the current user
*TmpApi* | [**listTmpEntityTemplates**](doc//TmpApi.md#listtmpentitytemplates) | **GET** /rest/v2/tmp/entityTemplate/list | List entityTemplates with the current user
*TmpApi* | [**listTmpForms**](doc//TmpApi.md#listtmpforms) | **GET** /rest/v2/tmp/form/list | List forms with the current user
*TmpApi* | [**listTmpHealthElements**](doc//TmpApi.md#listtmphealthelements) | **GET** /rest/v2/tmp/healthElement/list | List healthElements with the current user
*TmpApi* | [**listTmpInvoices**](doc//TmpApi.md#listtmpinvoices) | **GET** /rest/v2/tmp/invoice/list | List invoices with the current user
*TmpApi* | [**listTmpMessages**](doc//TmpApi.md#listtmpmessages) | **GET** /rest/v2/tmp/message/list | List messages with the current user
*TmpApi* | [**listTmpPatients**](doc//TmpApi.md#listtmppatients) | **GET** /rest/v2/tmp/patient/list | List patients with the current user
*TmpApi* | [**modifyTmpClassification**](doc//TmpApi.md#modifytmpclassification) | **PUT** /rest/v2/tmp/classification | Modify a classification
*TmpApi* | [**modifyTmpClassifications**](doc//TmpApi.md#modifytmpclassifications) | **PUT** /rest/v2/tmp/classification/batch | Modify a batch of healthcare elements
*TmpApi* | [**modifyTmpContact**](doc//TmpApi.md#modifytmpcontact) | **PUT** /rest/v2/tmp/contact | Modify a contact
*TmpApi* | [**modifyTmpContacts**](doc//TmpApi.md#modifytmpcontacts) | **PUT** /rest/v2/tmp/contact/batch | Modify a batch of healthcare elements
*TmpApi* | [**modifyTmpDocument**](doc//TmpApi.md#modifytmpdocument) | **PUT** /rest/v2/tmp/document | Modify a document
*TmpApi* | [**modifyTmpDocuments**](doc//TmpApi.md#modifytmpdocuments) | **PUT** /rest/v2/tmp/document/batch | Modify a batch of healthcare elements
*TmpApi* | [**modifyTmpEntityTemplate**](doc//TmpApi.md#modifytmpentitytemplate) | **PUT** /rest/v2/tmp/entityTemplate | Modify a entityTemplate
*TmpApi* | [**modifyTmpEntityTemplates**](doc//TmpApi.md#modifytmpentitytemplates) | **PUT** /rest/v2/tmp/entityTemplate/batch | Modify a batch of healthcare elements
*TmpApi* | [**modifyTmpForm**](doc//TmpApi.md#modifytmpform) | **PUT** /rest/v2/tmp/form | Modify a form
*TmpApi* | [**modifyTmpForms**](doc//TmpApi.md#modifytmpforms) | **PUT** /rest/v2/tmp/form/batch | Modify a batch of healthcare elements
*TmpApi* | [**modifyTmpHealthElement**](doc//TmpApi.md#modifytmphealthelement) | **PUT** /rest/v2/tmp/healthElement | Modify a healthElement
*TmpApi* | [**modifyTmpHealthElements**](doc//TmpApi.md#modifytmphealthelements) | **PUT** /rest/v2/tmp/healthElement/batch | Modify a batch of healthcare elements
*TmpApi* | [**modifyTmpInvoice**](doc//TmpApi.md#modifytmpinvoice) | **PUT** /rest/v2/tmp/invoice | Modify a invoice
*TmpApi* | [**modifyTmpInvoices**](doc//TmpApi.md#modifytmpinvoices) | **PUT** /rest/v2/tmp/invoice/batch | Modify a batch of healthcare elements
*TmpApi* | [**modifyTmpMessage**](doc//TmpApi.md#modifytmpmessage) | **PUT** /rest/v2/tmp/message | Modify a message
*TmpApi* | [**modifyTmpMessages**](doc//TmpApi.md#modifytmpmessages) | **PUT** /rest/v2/tmp/message/batch | Modify a batch of healthcare elements
*TmpApi* | [**modifyTmpPatient**](doc//TmpApi.md#modifytmppatient) | **PUT** /rest/v2/tmp/patient | Modify a patient
*TmpApi* | [**modifyTmpPatients**](doc//TmpApi.md#modifytmppatients) | **PUT** /rest/v2/tmp/patient/batch | Modify a batch of healthcare elements
*TmpApi* | [**purgeTmpItems**](doc//TmpApi.md#purgetmpitems) | **POST** /rest/v2/tmp/batch/purge | Hard delete items.
*TmpApi* | [**replicateToTmpDatabase**](doc//TmpApi.md#replicatetotmpdatabase) | **POST** /rest/v2/tmp/replicate/from/{from} | 
*UserApi* | [**assignHealthcareParty**](doc//UserApi.md#assignhealthcareparty) | **PUT** /rest/v2/user/current/hcparty/{healthcarePartyId} | Assign a healthcare party ID to current user
*UserApi* | [**checkPassword**](doc//UserApi.md#checkpassword) | **GET** /rest/v2/user/checkPassword | 
*UserApi* | [**checkTokenValidity**](doc//UserApi.md#checktokenvalidity) | **GET** /rest/v2/user/token/{userId} | Check token validity
*UserApi* | [**createUser**](doc//UserApi.md#createuser) | **POST** /rest/v2/user | Create a user
*UserApi* | [**createUserInGroup**](doc//UserApi.md#createuseringroup) | **POST** /rest/v2/user/inGroup/{groupId} | Create a user
*UserApi* | [**deleteUser**](doc//UserApi.md#deleteuser) | **DELETE** /rest/v2/user/{userId} | Delete a User based on his/her ID.
*UserApi* | [**deleteUserInGroup**](doc//UserApi.md#deleteuseringroup) | **DELETE** /rest/v2/user/inGroup/{groupId}/{userId} | Delete a User based on his/her ID.
*UserApi* | [**encodePassword**](doc//UserApi.md#encodepassword) | **GET** /rest/v2/user/encodePassword | 
*UserApi* | [**filterUsersBy**](doc//UserApi.md#filterusersby) | **POST** /rest/v2/user/filter | Filter users for the current user (HcParty)
*UserApi* | [**findByHcpartyId**](doc//UserApi.md#findbyhcpartyid) | **GET** /rest/v2/user/byHealthcarePartyId/{id} | Get the list of users by healthcare party id
*UserApi* | [**forgottenPassword**](doc//UserApi.md#forgottenpassword) | **POST** /rest/v2/user/forgottenPassword/{email} | Send a forgotten email message to an user
*UserApi* | [**getCurrentSession**](doc//UserApi.md#getcurrentsession) | **GET** /rest/v2/user/session | Get Currently logged-in user session.
*UserApi* | [**getCurrentUser**](doc//UserApi.md#getcurrentuser) | **GET** /rest/v2/user/current | Get presently logged-in user.
*UserApi* | [**getMatchingUsers**](doc//UserApi.md#getmatchingusers) | **GET** /rest/v2/user/matches | Get presently logged-in user.
*UserApi* | [**getToken**](doc//UserApi.md#gettoken) | **POST** /rest/v2/user/token/{userId}/{key} | Request a new temporary token for authentication
*UserApi* | [**getUser**](doc//UserApi.md#getuser) | **GET** /rest/v2/user/{userId} | Get a user by his ID
*UserApi* | [**getUserByEmail**](doc//UserApi.md#getuserbyemail) | **GET** /rest/v2/user/byEmail/{email} | Get a user by his Email/Login
*UserApi* | [**listUsersBy**](doc//UserApi.md#listusersby) | **GET** /rest/v2/user | List users with(out) pagination
*UserApi* | [**listUsersInGroup**](doc//UserApi.md#listusersingroup) | **GET** /rest/v2/user/inGroup/{groupId} | List users with(out) pagination
*UserApi* | [**matchUsersBy**](doc//UserApi.md#matchusersby) | **POST** /rest/v2/user/match | Get ids of healthcare party matching the provided filter for the current user (HcParty) 
*UserApi* | [**modifyProperties**](doc//UserApi.md#modifyproperties) | **PUT** /rest/v2/user/{userId}/properties | Modify a User property
*UserApi* | [**modifyUser**](doc//UserApi.md#modifyuser) | **PUT** /rest/v2/user | Modify a user.
*UserApi* | [**modifyUserInGroup**](doc//UserApi.md#modifyuseringroup) | **PUT** /rest/v2/user/inGroup/{groupId} | Modify a user.


## Documentation For Models

 - [AbstractFilterDtoCode](doc//AbstractFilterDtoCode.md)
 - [AbstractFilterDtoContact](doc//AbstractFilterDtoContact.md)
 - [AbstractFilterDtoDevice](doc//AbstractFilterDtoDevice.md)
 - [AbstractFilterDtoHealthElement](doc//AbstractFilterDtoHealthElement.md)
 - [AbstractFilterDtoHealthcareParty](doc//AbstractFilterDtoHealthcareParty.md)
 - [AbstractFilterDtoInvoice](doc//AbstractFilterDtoInvoice.md)
 - [AbstractFilterDtoPatient](doc//AbstractFilterDtoPatient.md)
 - [AbstractFilterDtoService](doc//AbstractFilterDtoService.md)
 - [AbstractFilterDtoUser](doc//AbstractFilterDtoUser.md)
 - [AccessLogDto](doc//AccessLogDto.md)
 - [AddressDto](doc//AddressDto.md)
 - [AdministrationQuantity](doc//AdministrationQuantity.md)
 - [AgendaDto](doc//AgendaDto.md)
 - [AgreementAppendixDto](doc//AgreementAppendixDto.md)
 - [AmpComponentDto](doc//AmpComponentDto.md)
 - [AmpDto](doc//AmpDto.md)
 - [AmppComponentDto](doc//AmppComponentDto.md)
 - [AmppDto](doc//AmppDto.md)
 - [AnnotationDto](doc//AnnotationDto.md)
 - [ApplicationSettingsDto](doc//ApplicationSettingsDto.md)
 - [ArticleDto](doc//ArticleDto.md)
 - [AtcDto](doc//AtcDto.md)
 - [Authentication](doc//Authentication.md)
 - [AuthenticationResponse](doc//AuthenticationResponse.md)
 - [AuthenticationTokenDto](doc//AuthenticationTokenDto.md)
 - [Basic](doc//Basic.md)
 - [BasicDto](doc//BasicDto.md)
 - [ByteArrayDto](doc//ByteArrayDto.md)
 - [CalendarItemDto](doc//CalendarItemDto.md)
 - [CalendarItemTagDto](doc//CalendarItemTagDto.md)
 - [CalendarItemTypeDto](doc//CalendarItemTypeDto.md)
 - [CareTeamMemberDto](doc//CareTeamMemberDto.md)
 - [CareTeamMembershipDto](doc//CareTeamMembershipDto.md)
 - [CheckSMFPatientResult](doc//CheckSMFPatientResult.md)
 - [ClassificationDto](doc//ClassificationDto.md)
 - [ClassificationTemplateDto](doc//ClassificationTemplateDto.md)
 - [CodeDto](doc//CodeDto.md)
 - [CodeStub](doc//CodeStub.md)
 - [CodeStubDto](doc//CodeStubDto.md)
 - [CommentedClassificationDto](doc//CommentedClassificationDto.md)
 - [CommercializationDto](doc//CommercializationDto.md)
 - [CompanyDto](doc//CompanyDto.md)
 - [ContactDto](doc//ContactDto.md)
 - [ContentDto](doc//ContentDto.md)
 - [CopaymentDto](doc//CopaymentDto.md)
 - [DatabaseInitialisationDto](doc//DatabaseInitialisationDto.md)
 - [DatabaseSynchronizationDto](doc//DatabaseSynchronizationDto.md)
 - [DelegationDto](doc//DelegationDto.md)
 - [DeviceDto](doc//DeviceDto.md)
 - [DeviceTypeDto](doc//DeviceTypeDto.md)
 - [DiaryNoteExportInfoDto](doc//DiaryNoteExportInfoDto.md)
 - [DmppDto](doc//DmppDto.md)
 - [DocIdentifier](doc//DocIdentifier.md)
 - [DocumentDto](doc//DocumentDto.md)
 - [DocumentGroupDto](doc//DocumentGroupDto.md)
 - [DocumentTemplateDto](doc//DocumentTemplateDto.md)
 - [DurationDto](doc//DurationDto.md)
 - [EIDItem](doc//EIDItem.md)
 - [Editor](doc//Editor.md)
 - [EfactInvoice](doc//EfactInvoice.md)
 - [EmailTemplateDto](doc//EmailTemplateDto.md)
 - [EmployerDto](doc//EmployerDto.md)
 - [EmploymentInfoDto](doc//EmploymentInfoDto.md)
 - [EntityReferenceDto](doc//EntityReferenceDto.md)
 - [EntityTemplateDto](doc//EntityTemplateDto.md)
 - [EpisodeDto](doc//EpisodeDto.md)
 - [FilterChainCode](doc//FilterChainCode.md)
 - [FilterChainContact](doc//FilterChainContact.md)
 - [FilterChainDevice](doc//FilterChainDevice.md)
 - [FilterChainHealthElement](doc//FilterChainHealthElement.md)
 - [FilterChainHealthcareParty](doc//FilterChainHealthcareParty.md)
 - [FilterChainInvoice](doc//FilterChainInvoice.md)
 - [FilterChainPatient](doc//FilterChainPatient.md)
 - [FilterChainService](doc//FilterChainService.md)
 - [FilterChainUser](doc//FilterChainUser.md)
 - [FinancialInstitutionInformationDto](doc//FinancialInstitutionInformationDto.md)
 - [FlatRateTarificationDto](doc//FlatRateTarificationDto.md)
 - [FlowItemDto](doc//FlowItemDto.md)
 - [FormColumn](doc//FormColumn.md)
 - [FormDataOption](doc//FormDataOption.md)
 - [FormDto](doc//FormDto.md)
 - [FormLayout](doc//FormLayout.md)
 - [FormLayoutData](doc//FormLayoutData.md)
 - [FormPlanning](doc//FormPlanning.md)
 - [FormSection](doc//FormSection.md)
 - [FormTemplateDto](doc//FormTemplateDto.md)
 - [FormTemplateLayout](doc//FormTemplateLayout.md)
 - [Formula](doc//Formula.md)
 - [FrontEndMigrationDto](doc//FrontEndMigrationDto.md)
 - [GroupDto](doc//GroupDto.md)
 - [GuiCode](doc//GuiCode.md)
 - [GuiCodeType](doc//GuiCodeType.md)
 - [HealthElementDto](doc//HealthElementDto.md)
 - [HealthcarePartyDto](doc//HealthcarePartyDto.md)
 - [HealthcarePartyHistoryStatusDto](doc//HealthcarePartyHistoryStatusDto.md)
 - [IcureStubDto](doc//IcureStubDto.md)
 - [IdWithRevDto](doc//IdWithRevDto.md)
 - [IdentifierDto](doc//IdentifierDto.md)
 - [IdentityDocumentReaderDto](doc//IdentityDocumentReaderDto.md)
 - [ImportMapping](doc//ImportMapping.md)
 - [ImportResultDto](doc//ImportResultDto.md)
 - [IndexingInfoDto](doc//IndexingInfoDto.md)
 - [IngredientDto](doc//IngredientDto.md)
 - [InsurabilityDto](doc//InsurabilityDto.md)
 - [InsuranceDto](doc//InsuranceDto.md)
 - [InvoiceDto](doc//InvoiceDto.md)
 - [InvoiceItem](doc//InvoiceItem.md)
 - [InvoiceSender](doc//InvoiceSender.md)
 - [InvoicesBatch](doc//InvoicesBatch.md)
 - [InvoicingCodeDto](doc//InvoicingCodeDto.md)
 - [KeywordDto](doc//KeywordDto.md)
 - [KeywordSubwordDto](doc//KeywordSubwordDto.md)
 - [LabelledOccurenceDto](doc//LabelledOccurenceDto.md)
 - [LetterValueDto](doc//LetterValueDto.md)
 - [ListOfIdsDto](doc//ListOfIdsDto.md)
 - [ListOfPropertiesDto](doc//ListOfPropertiesDto.md)
 - [LoginCredentials](doc//LoginCredentials.md)
 - [MapOfIdsDto](doc//MapOfIdsDto.md)
 - [MeasureDto](doc//MeasureDto.md)
 - [MedexInfoDto](doc//MedexInfoDto.md)
 - [MedicalHouseContractDto](doc//MedicalHouseContractDto.md)
 - [MedicalLocationDto](doc//MedicalLocationDto.md)
 - [MedicationDto](doc//MedicationDto.md)
 - [MedicationSchemeExportInfoDto](doc//MedicationSchemeExportInfoDto.md)
 - [MedicinalproductDto](doc//MedicinalproductDto.md)
 - [MessageDto](doc//MessageDto.md)
 - [MessageReadStatusDto](doc//MessageReadStatusDto.md)
 - [MessageWithBatch](doc//MessageWithBatch.md)
 - [MessagesReadStatusUpdate](doc//MessagesReadStatusUpdate.md)
 - [MimeAttachmentDto](doc//MimeAttachmentDto.md)
 - [NmpDto](doc//NmpDto.md)
 - [NoGenericPrescriptionReasonDto](doc//NoGenericPrescriptionReasonDto.md)
 - [NoSwitchReasonDto](doc//NoSwitchReasonDto.md)
 - [NumeratorRangeDto](doc//NumeratorRangeDto.md)
 - [PackagingTypeDto](doc//PackagingTypeDto.md)
 - [PaginatedDocumentKeyIdPairObject](doc//PaginatedDocumentKeyIdPairObject.md)
 - [PaginatedListAccessLogDto](doc//PaginatedListAccessLogDto.md)
 - [PaginatedListAmpDto](doc//PaginatedListAmpDto.md)
 - [PaginatedListClassificationDto](doc//PaginatedListClassificationDto.md)
 - [PaginatedListClassificationTemplateDto](doc//PaginatedListClassificationTemplateDto.md)
 - [PaginatedListCodeDto](doc//PaginatedListCodeDto.md)
 - [PaginatedListContactDto](doc//PaginatedListContactDto.md)
 - [PaginatedListDeviceDto](doc//PaginatedListDeviceDto.md)
 - [PaginatedListDocumentDto](doc//PaginatedListDocumentDto.md)
 - [PaginatedListEntityTemplateDto](doc//PaginatedListEntityTemplateDto.md)
 - [PaginatedListFormDto](doc//PaginatedListFormDto.md)
 - [PaginatedListHealthElementDto](doc//PaginatedListHealthElementDto.md)
 - [PaginatedListHealthcarePartyDto](doc//PaginatedListHealthcarePartyDto.md)
 - [PaginatedListInvoiceDto](doc//PaginatedListInvoiceDto.md)
 - [PaginatedListMessageDto](doc//PaginatedListMessageDto.md)
 - [PaginatedListNmpDto](doc//PaginatedListNmpDto.md)
 - [PaginatedListPatientDto](doc//PaginatedListPatientDto.md)
 - [PaginatedListServiceDto](doc//PaginatedListServiceDto.md)
 - [PaginatedListString](doc//PaginatedListString.md)
 - [PaginatedListTarificationDto](doc//PaginatedListTarificationDto.md)
 - [PaginatedListUserDto](doc//PaginatedListUserDto.md)
 - [PaginatedListVmpDto](doc//PaginatedListVmpDto.md)
 - [PaginatedListVmpGroupDto](doc//PaginatedListVmpGroupDto.md)
 - [ParagraphAgreementDto](doc//ParagraphAgreementDto.md)
 - [PartnershipDto](doc//PartnershipDto.md)
 - [PatientDto](doc//PatientDto.md)
 - [PatientHealthCarePartyDto](doc//PatientHealthCarePartyDto.md)
 - [PatientRegistrationSuccessDto](doc//PatientRegistrationSuccessDto.md)
 - [PaymentDto](doc//PaymentDto.md)
 - [PeriodicityDto](doc//PeriodicityDto.md)
 - [PermissionDto](doc//PermissionDto.md)
 - [PermissionItemDto](doc//PermissionItemDto.md)
 - [PersonNameDto](doc//PersonNameDto.md)
 - [PharmaceuticalFormDto](doc//PharmaceuticalFormDto.md)
 - [PharmaceuticalFormStubDto](doc//PharmaceuticalFormStubDto.md)
 - [PlaceDto](doc//PlaceDto.md)
 - [PlanOfActionDto](doc//PlanOfActionDto.md)
 - [PricingDto](doc//PricingDto.md)
 - [PropertyStubDto](doc//PropertyStubDto.md)
 - [PropertyTypeStubDto](doc//PropertyTypeStubDto.md)
 - [PublicKeyDto](doc//PublicKeyDto.md)
 - [QuantityDto](doc//QuantityDto.md)
 - [ReceiptDto](doc//ReceiptDto.md)
 - [ReferralPeriodDto](doc//ReferralPeriodDto.md)
 - [RegimenItemDto](doc//RegimenItemDto.md)
 - [RegistrationInformationDto](doc//RegistrationInformationDto.md)
 - [RegistrationSuccessDto](doc//RegistrationSuccessDto.md)
 - [ReimbursementCriterionDto](doc//ReimbursementCriterionDto.md)
 - [ReimbursementDto](doc//ReimbursementDto.md)
 - [Remote](doc//Remote.md)
 - [RemoteAuthenticationDto](doc//RemoteAuthenticationDto.md)
 - [RemoteDto](doc//RemoteDto.md)
 - [RenewalDto](doc//RenewalDto.md)
 - [ReplicationDto](doc//ReplicationDto.md)
 - [ReplicationInfoDto](doc//ReplicationInfoDto.md)
 - [ReplicationStats](doc//ReplicationStats.md)
 - [ReplicationStatsDto](doc//ReplicationStatsDto.md)
 - [ReplicatorDocument](doc//ReplicatorDocument.md)
 - [ReplicatorDocumentDto](doc//ReplicatorDocumentDto.md)
 - [ResultInfoDto](doc//ResultInfoDto.md)
 - [RightDto](doc//RightDto.md)
 - [RouteOfAdministrationDto](doc//RouteOfAdministrationDto.md)
 - [SamTextDto](doc//SamTextDto.md)
 - [SamVersionDto](doc//SamVersionDto.md)
 - [SchoolingInfoDto](doc//SchoolingInfoDto.md)
 - [Section](doc//Section.md)
 - [ServiceDto](doc//ServiceDto.md)
 - [ServiceLinkDto](doc//ServiceLinkDto.md)
 - [SoftwareMedicalFileExportDto](doc//SoftwareMedicalFileExportDto.md)
 - [StandardSubstanceDto](doc//StandardSubstanceDto.md)
 - [StrengthRangeDto](doc//StrengthRangeDto.md)
 - [SubContactDto](doc//SubContactDto.md)
 - [SubstanceDto](doc//SubstanceDto.md)
 - [SubstanceStubDto](doc//SubstanceStubDto.md)
 - [SubstanceproductDto](doc//SubstanceproductDto.md)
 - [Suggest](doc//Suggest.md)
 - [SumehrContentDto](doc//SumehrContentDto.md)
 - [SumehrExportInfoDto](doc//SumehrExportInfoDto.md)
 - [SumehrValidityDto](doc//SumehrValidityDto.md)
 - [SupplyProblemDto](doc//SupplyProblemDto.md)
 - [SuspensionDto](doc//SuspensionDto.md)
 - [Tag](doc//Tag.md)
 - [TarificationDto](doc//TarificationDto.md)
 - [TelecomDto](doc//TelecomDto.md)
 - [TimeSeriesDto](doc//TimeSeriesDto.md)
 - [TimeTableDto](doc//TimeTableDto.md)
 - [TimeTableHourDto](doc//TimeTableHourDto.md)
 - [TimeTableItemDto](doc//TimeTableItemDto.md)
 - [TypedValueDtoObject](doc//TypedValueDtoObject.md)
 - [UserDto](doc//UserDto.md)
 - [UserGroupDto](doc//UserGroupDto.md)
 - [ValorisationDto](doc//ValorisationDto.md)
 - [VirtualFormDto](doc//VirtualFormDto.md)
 - [VirtualIngredientDto](doc//VirtualIngredientDto.md)
 - [VmpComponentDto](doc//VmpComponentDto.md)
 - [VmpDto](doc//VmpDto.md)
 - [VmpGroupDto](doc//VmpGroupDto.md)
 - [VmpGroupStubDto](doc//VmpGroupStubDto.md)
 - [VmpStubDto](doc//VmpStubDto.md)
 - [VtmDto](doc//VtmDto.md)
 - [WadaDto](doc//WadaDto.md)
 - [Weekday](doc//Weekday.md)


## Documentation For Authorization


## basicSchema

- **Type**: HTTP Basic authentication


## Author



